/* nibbles-game.c generated by valac 0.56.3, the Vala compiler
 * generated from nibbles-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This is a fairly literal translation of the GPLv2+ original by*/
/* Sean MacIsaac, Ian Peters, Guillaume Béland.*/

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define NIBBLES_GAME_MAX_WORMS 6
#define NIBBLES_GAME_MAX_SPEED 4
#define NIBBLES_GAME_EMPTYCHAR 'a'
#define NIBBLES_GAME_WORMCHAR 'w'
#define NIBBLES_GAME_WARPCHAR 'W'
#define NIBBLES_GAME_MAX_LEVEL 26
#define WORM_GROW_FACTOR 4
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	GAME_STATUS_GAMEOVER,
	GAME_STATUS_VICTORY,
	GAME_STATUS_NEWROUND
} GameStatus;

#define TYPE_GAME_STATUS (game_status_get_type ())

#define TYPE_NIBBLES_GAME (nibbles_game_get_type ())
#define NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_GAME, NibblesGame))
#define NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_GAME, NibblesGameClass))
#define IS_NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_GAME))
#define IS_NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_GAME))
#define NIBBLES_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_GAME, NibblesGameClass))

typedef struct _NibblesGame NibblesGame;
typedef struct _NibblesGameClass NibblesGameClass;
typedef struct _NibblesGamePrivate NibblesGamePrivate;

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;

#define TYPE_BONI (boni_get_type ())
#define BONI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONI, Boni))
#define BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONI, BoniClass))
#define IS_BONI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONI))
#define IS_BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONI))
#define BONI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONI, BoniClass))

typedef struct _Boni Boni;
typedef struct _BoniClass BoniClass;

#define TYPE_WARP_MANAGER (warp_manager_get_type ())
#define WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARP_MANAGER, WarpManager))
#define WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARP_MANAGER, WarpManagerClass))
#define IS_WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARP_MANAGER))
#define IS_WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARP_MANAGER))
#define WARP_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARP_MANAGER, WarpManagerClass))

typedef struct _WarpManager WarpManager;
typedef struct _WarpManagerClass WarpManagerClass;
enum  {
	NIBBLES_GAME_0_PROPERTY,
	NIBBLES_GAME_SKIP_SCORE_PROPERTY,
	NIBBLES_GAME_CURRENT_LEVEL_PROPERTY,
	NIBBLES_GAME_SPEED_PROPERTY,
	NIBBLES_GAME_GAMEDELAY_PROPERTY,
	NIBBLES_GAME_WIDTH_PROPERTY,
	NIBBLES_GAME_HEIGHT_PROPERTY,
	NIBBLES_GAME_NUMHUMANS_PROPERTY,
	NIBBLES_GAME_NUMAI_PROPERTY,
	NIBBLES_GAME_NUMWORMS_PROPERTY,
	NIBBLES_GAME_WORMS_PROPERTY,
	NIBBLES_GAME_WORM_PROPS_PROPERTY,
	NIBBLES_GAME_IS_RUNNING_PROPERTY,
	NIBBLES_GAME_IS_PAUSED_PROPERTY,
	NIBBLES_GAME_FAKES_PROPERTY,
	NIBBLES_GAME_NUM_PROPERTIES
};
static GParamSpec* nibbles_game_properties[NIBBLES_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())
typedef struct _WormPrivate WormPrivate;

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;
typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;
enum  {
	NIBBLES_GAME_BONUS_APPLIED_SIGNAL,
	NIBBLES_GAME_LOG_SCORE_SIGNAL,
	NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL,
	NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL,
	NIBBLES_GAME_WARP_ADDED_SIGNAL,
	NIBBLES_GAME_BONUS_ADDED_SIGNAL,
	NIBBLES_GAME_BONUS_REMOVED_SIGNAL,
	NIBBLES_GAME_NUM_SIGNALS
};
static guint nibbles_game_signals[NIBBLES_GAME_NUM_SIGNALS] = {0};

struct _NibblesGame {
	GObject parent_instance;
	NibblesGamePrivate * priv;
	gint* board;
	gint board_length1;
	gint board_length2;
};

struct _NibblesGameClass {
	GObjectClass parent_class;
};

struct _NibblesGamePrivate {
	gboolean _skip_score;
	gint _current_level;
	gint _speed;
	gint _gamedelay;
	guint8 _width;
	guint8 _height;
	gint _numhumans;
	gint _numai;
	gint _numworms;
	GeeLinkedList* _worms;
	GeeHashMap* _worm_props;
	Boni* boni;
	WarpManager* warp_manager;
	gboolean _is_running;
	gboolean _is_paused;
	guint main_id;
	gboolean _fakes;
	guint8 bonus_cycle;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gboolean keypress;
	gboolean is_stopped;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _Position {
	guint8 x;
	guint8 y;
};

static gint NibblesGame_private_offset;
static gpointer nibbles_game_parent_class = NULL;

VALA_EXTERN GType game_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType nibbles_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesGame, g_object_unref)
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
VALA_EXTERN GType boni_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Boni, g_object_unref)
VALA_EXTERN GType warp_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarpManager, g_object_unref)
VALA_EXTERN Boni* boni_new (void);
VALA_EXTERN Boni* boni_construct (GType object_type);
VALA_EXTERN WarpManager* warp_manager_new (void);
VALA_EXTERN WarpManager* warp_manager_construct (GType object_type);
VALA_EXTERN NibblesGame* nibbles_game_new (gint start_level,
                               gint speed,
                               gint gamedelay,
                               gboolean fakes,
                               guint8 width,
                               guint8 height,
                               gboolean no_random);
VALA_EXTERN NibblesGame* nibbles_game_construct (GType object_type,
                                     gint start_level,
                                     gint speed,
                                     gint gamedelay,
                                     gboolean fakes,
                                     guint8 width,
                                     guint8 height,
                                     gboolean no_random);
VALA_EXTERN gboolean nibbles_game_load_board (NibblesGame* self,
                                  gchar** future_board,
                                  gint future_board_length1,
                                  guint8 regular_bonus);
VALA_EXTERN guint8 nibbles_game_get_height (NibblesGame* self);
VALA_EXTERN void boni_reset (Boni* self,
                 guint8 regular_bonus);
VALA_EXTERN void warp_manager_clear_warps (WarpManager* self);
VALA_EXTERN guint8 nibbles_game_get_width (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_numworms (NibblesGame* self);
VALA_EXTERN GeeLinkedList* nibbles_game_get_worms (NibblesGame* self);
VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void worm_set_start (Worm* self,
                     guint8 x,
                     guint8 y,
                     WormDirection direction);
VALA_EXTERN void warp_manager_add_warp_source (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
VALA_EXTERN void warp_manager_add_warp_target (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
VALA_EXTERN void nibbles_game_start (NibblesGame* self,
                         gboolean add_initial_bonus);
static void nibbles_game_add_bonus (NibblesGame* self,
                             gboolean regular);
static void nibbles_game_set_is_running (NibblesGame* self,
                                  gboolean value);
VALA_EXTERN gint nibbles_game_get_gamedelay (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_speed (NibblesGame* self);
static gboolean __lambda5_ (NibblesGame* self);
static gboolean nibbles_game_main_loop_cb (NibblesGame* self);
static gboolean ___lambda5__gsource_func (gpointer self);
VALA_EXTERN void nibbles_game_stop (NibblesGame* self);
VALA_EXTERN void nibbles_game_pause (NibblesGame* self);
static void nibbles_game_set_is_paused (NibblesGame* self,
                                 gboolean value);
VALA_EXTERN void nibbles_game_unpause (NibblesGame* self);
VALA_EXTERN void nibbles_game_reset (NibblesGame* self,
                         gint start_level);
VALA_EXTERN void nibbles_game_set_skip_score (NibblesGame* self,
                                  gboolean value);
VALA_EXTERN void nibbles_game_set_current_level (NibblesGame* self,
                                     gint value);
static void nibbles_game_end (NibblesGame* self);
VALA_EXTERN GameStatus* nibbles_game_get_game_status (NibblesGame* self);
static gboolean _game_status_equal (const GameStatus * s1,
                             const GameStatus * s2);
VALA_EXTERN gint worm_get_score (Worm* self);
VALA_EXTERN gint nibbles_game_get_current_level (NibblesGame* self);
VALA_EXTERN Worm* nibbles_game_get_winner (NibblesGame* self);
static void nibbles_game_move_worms (NibblesGame* self);
VALA_EXTERN void nibbles_game_create_worms (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_numai (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_numhumans (NibblesGame* self);
static void nibbles_game_set_numworms (NibblesGame* self,
                                gint value);
VALA_EXTERN Worm* worm_new (gint id,
                guint8 width,
                guint8 height);
VALA_EXTERN Worm* worm_construct (GType object_type,
                      gint id,
                      guint8 width,
                      guint8 height);
static void nibbles_game_bonus_found_cb (NibblesGame* self,
                                  Worm* worm);
static void _nibbles_game_bonus_found_cb_worm_bonus_found (Worm* _sender,
                                                    gpointer self);
static void nibbles_game_worm_dematerialization_request (NibblesGame* self,
                                                  Worm* worm);
static void _nibbles_game_worm_dematerialization_request_worm_finish_added (Worm* _sender,
                                                                     gpointer self);
VALA_EXTERN void nibbles_game_add_worms (NibblesGame* self);
VALA_EXTERN void worm_spawn (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
VALA_EXTERN gboolean boni_too_many_missed (Boni* self);
VALA_EXTERN void worm_set_score (Worm* self,
                     gint value);
VALA_EXTERN void boni_on_worms_move (Boni* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         guint8* missed_bonuses_to_replace);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
VALA_EXTERN GeeLinkedList* worm_get_list (Worm* self);
VALA_EXTERN void worm_ai_move (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   gint numworms,
                   GeeLinkedList* worms);
VALA_EXTERN void worm_position_move (Worm* self,
                         Position* result);
VALA_EXTERN WormDirection worm_get_direction (Worm* self);
VALA_EXTERN gboolean warp_manager_get_warp_target (WarpManager* self,
                                       guint8 x,
                                       guint8 y,
                                       gboolean horizontal,
                                       guint8* target_x,
                                       guint8* target_y);
VALA_EXTERN gboolean worm_can_move_to (Worm* self,
                           gint* board,
                           gint board_length1,
                           gint board_length2,
                           gint numworms,
                           Position* position);
VALA_EXTERN void worm_move_part_1 (Worm* self);
VALA_EXTERN void worm_get_head (Worm* self,
                    Position * result);
VALA_EXTERN void worm_move_part_2 (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       Position* head_position);
VALA_EXTERN guint8 worm_get_lives (Worm* self);
VALA_EXTERN void worm_reset (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
static void nibbles_game_reverse_worms (NibblesGame* self,
                                 Worm* worm);
VALA_EXTERN void worm_reverse (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2);
VALA_EXTERN void worm_dematerialize (Worm* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         gint rounds,
                         gint gamedelay);
VALA_EXTERN gboolean nibbles_game_get_fakes (NibblesGame* self);
VALA_EXTERN GType bonus_type_get_type (void) G_GNUC_CONST ;
static inline void _nibbles_game_add_bonus (NibblesGame* self,
                              guint8 x,
                              guint8 y,
                              BonusType bonus_type,
                              gboolean fake,
                              guint16 countdown);
VALA_EXTERN GType bonus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
VALA_EXTERN Bonus* bonus_new (guint8 x,
                  guint8 y,
                  BonusType bonus_type,
                  gboolean fake,
                  guint16 countdown);
VALA_EXTERN Bonus* bonus_construct (GType object_type,
                        guint8 x,
                        guint8 y,
                        BonusType bonus_type,
                        gboolean fake,
                        guint16 countdown);
VALA_EXTERN gboolean boni_add_bonus (Boni* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         Bonus* bonus);
static void nibbles_game_apply_bonus (NibblesGame* self,
                               Bonus* bonus,
                               Worm* worm);
VALA_EXTERN gboolean bonus_get_fake (Bonus* self);
VALA_EXTERN guint8 boni_new_regular_bonus_eaten (Boni* self);
VALA_EXTERN gint worm_get_change (Worm* self);
VALA_EXTERN void worm_set_change (Worm* self,
                      gint value);
VALA_EXTERN gint worm_get_length (Worm* self);
VALA_EXTERN void worm_reduce_tail (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       gint erase_size);
VALA_EXTERN void worm_add_life (Worm* self);
VALA_EXTERN Bonus* boni_get_bonus (Boni* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       guint8 x,
                       guint8 y);
VALA_EXTERN void boni_remove_bonus (Boni* self,
                        gint* board,
                        gint board_length1,
                        gint board_length2,
                        Bonus* bonus);
VALA_EXTERN gboolean boni_last_regular_bonus (Boni* self);
static GameStatus* _game_status_dup (GameStatus* self);
VALA_EXTERN void nibbles_game_load_worm_properties (NibblesGame* self,
                                        GeeArrayList* worm_settings);
VALA_EXTERN GeeHashMap* nibbles_game_get_worm_props (NibblesGame* self);
VALA_EXTERN WormProperties* worm_properties_new (void);
VALA_EXTERN WormProperties* worm_properties_construct (GType object_type);
VALA_EXTERN gint worm_get_id (Worm* self);
static gboolean ____lambda6_ (GValue* prop_value,
                       GVariant* variant);
static inline gint nibbles_game_get_color_num (const gchar* color);
static gboolean _____lambda6__gsettings_bind_get_mapping (GValue* value,
                                                   GVariant* variant,
                                                   void* user_data);
static GVariant* ____lambda7_ (GValue* prop_value,
                        const GVariantType* variant_type);
static inline gchar* nibbles_game_get_color_string (gint color);
static GVariant* _____lambda7__gsettings_bind_set_mapping (GValue* value,
                                                    const GVariantType* expected_type,
                                                    void* user_data);
VALA_EXTERN gboolean nibbles_game_handle_keypress (NibblesGame* self,
                                       guint keyval);
VALA_EXTERN gboolean nibbles_game_get_is_running (NibblesGame* self);
VALA_EXTERN gboolean worm_handle_keypress (Worm* self,
                               guint keyval,
                               GeeHashMap* worm_props);
VALA_EXTERN gboolean nibbles_game_get_skip_score (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_speed (NibblesGame* self,
                             gint value);
static void nibbles_game_set_gamedelay (NibblesGame* self,
                                 gint value);
static void nibbles_game_set_width (NibblesGame* self,
                             guint8 value);
static void nibbles_game_set_height (NibblesGame* self,
                              guint8 value);
VALA_EXTERN void nibbles_game_set_numhumans (NibblesGame* self,
                                 gint value);
VALA_EXTERN void nibbles_game_set_numai (NibblesGame* self,
                             gint value);
VALA_EXTERN gboolean nibbles_game_get_is_paused (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_fakes (NibblesGame* self,
                             gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * nibbles_game_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _nibbles_game___lambda8_ (NibblesGame* self,
                               Bonus* bonus);
static void __nibbles_game___lambda8__boni_bonus_removed (Boni* _sender,
                                                   Bonus* bonus,
                                                   gpointer self);
static void nibbles_game_finalize (GObject * obj);
static GType nibbles_game_get_type_once (void);
static void _vala_nibbles_game_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_nibbles_game_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static GType
game_status_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_STATUS_GAMEOVER, "GAME_STATUS_GAMEOVER", "gameover"}, {GAME_STATUS_VICTORY, "GAME_STATUS_VICTORY", "victory"}, {GAME_STATUS_NEWROUND, "GAME_STATUS_NEWROUND", "newround"}, {0, NULL, NULL}};
	GType game_status_type_id;
	game_status_type_id = g_enum_register_static ("GameStatus", values);
	return game_status_type_id;
}

GType
game_status_get_type (void)
{
	static volatile gsize game_status_type_id__once = 0;
	if (g_once_init_enter (&game_status_type_id__once)) {
		GType game_status_type_id;
		game_status_type_id = game_status_get_type_once ();
		g_once_init_leave (&game_status_type_id__once, game_status_type_id);
	}
	return game_status_type_id__once;
}

static inline gpointer
nibbles_game_get_instance_private (NibblesGame* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesGame_private_offset);
}

NibblesGame*
nibbles_game_construct (GType object_type,
                        gint start_level,
                        gint speed,
                        gint gamedelay,
                        gboolean fakes,
                        guint8 width,
                        guint8 height,
                        gboolean no_random)
{
	NibblesGame * self = NULL;
	guint32 _tmp0_ = 0U;
	self = (NibblesGame*) g_object_new (object_type, "skip-score", start_level != 1, "current-level", start_level, "speed", speed, "gamedelay", gamedelay, "fakes", fakes, "width", width, "height", height, NULL);
	if (no_random) {
		_tmp0_ = (guint32) 42;
	} else {
		time_t _tmp1_;
		_tmp1_ = time (NULL);
		_tmp0_ = (guint32) _tmp1_;
	}
	g_random_set_seed (_tmp0_);
	return self;
}

NibblesGame*
nibbles_game_new (gint start_level,
                  gint speed,
                  gint gamedelay,
                  gboolean fakes,
                  guint8 width,
                  guint8 height,
                  gboolean no_random)
{
	return nibbles_game_construct (TYPE_NIBBLES_GAME, start_level, speed, gamedelay, fakes, width, height, no_random);
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
	g_return_val_if_fail (self != NULL, 0U);
	result = g_utf8_get_char (((gchar*) self) + index);
	return result;
}

static gint
string_index_of_nth_char (const gchar* self,
                          glong c)
{
	gchar* _tmp0_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_offset_to_pointer (self, c);
	result = (gint) (_tmp0_ - ((gchar*) self));
	return result;
}

gboolean
nibbles_game_load_board (NibblesGame* self,
                         gchar** future_board,
                         gint future_board_length1,
                         guint8 regular_bonus)
{
	guint8 _tmp0_;
	Boni* _tmp1_;
	WarpManager* _tmp2_;
	gchar* tmpboard = NULL;
	gint count = 0;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_height;
	if (future_board_length1 != ((gint) _tmp0_)) {
		result = FALSE;
		return result;
	}
	_tmp1_ = self->priv->boni;
	boni_reset (_tmp1_, regular_bonus);
	_tmp2_ = self->priv->warp_manager;
	warp_manager_clear_warps (_tmp2_);
	count = 0;
	{
		guint8 i = 0U;
		i = (guint8) 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				guint8 _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				guint8 _tmp9_;
				if (!_tmp3_) {
					guint8 _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = self->priv->_height;
				if (!(i < _tmp5_)) {
					break;
				}
				_tmp6_ = future_board[i];
				_tmp7_ = g_strdup (_tmp6_);
				_g_free0 (tmpboard);
				tmpboard = _tmp7_;
				_tmp8_ = tmpboard;
				_tmp9_ = self->priv->_width;
				if (g_utf8_strlen (_tmp8_, (gssize) -1) != ((gint) _tmp9_)) {
					result = FALSE;
					_g_free0 (tmpboard);
					return result;
				}
				{
					guint8 j = 0U;
					j = (guint8) 0;
					{
						gboolean _tmp10_ = FALSE;
						_tmp10_ = TRUE;
						while (TRUE) {
							guint8 _tmp12_;
							gunichar char_value = 0U;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
							if (!_tmp10_) {
								guint8 _tmp11_;
								_tmp11_ = j;
								j = _tmp11_ + 1;
							}
							_tmp10_ = FALSE;
							_tmp12_ = self->priv->_width;
							if (!(j < _tmp12_)) {
								break;
							}
							_tmp13_ = tmpboard;
							_tmp14_ = tmpboard;
							char_value = string_get_char (_tmp13_, (glong) string_index_of_nth_char (_tmp14_, (glong) j));
							switch (char_value) {
								case '.':
								case '+':
								{
									gint* _tmp15_;
									gint _tmp15__length1;
									gint _tmp15__length2;
									_tmp15_ = self->board;
									_tmp15__length1 = self->board_length1;
									_tmp15__length2 = self->board_length2;
									_tmp15_[(j * _tmp15__length2) + i] = (gint) 'a';
									break;
								}
								case 9475U:
								{
									gint* _tmp16_;
									gint _tmp16__length1;
									gint _tmp16__length2;
									_tmp16_ = self->board;
									_tmp16__length1 = self->board_length1;
									_tmp16__length2 = self->board_length2;
									_tmp16_[(j * _tmp16__length2) + i] = (gint) 'b';
									break;
								}
								case 9473U:
								{
									gint* _tmp17_;
									gint _tmp17__length1;
									gint _tmp17__length2;
									_tmp17_ = self->board;
									_tmp17__length1 = self->board_length1;
									_tmp17__length2 = self->board_length2;
									_tmp17_[(j * _tmp17__length2) + i] = (gint) 'c';
									break;
								}
								case 9495U:
								{
									gint* _tmp18_;
									gint _tmp18__length1;
									gint _tmp18__length2;
									_tmp18_ = self->board;
									_tmp18__length1 = self->board_length1;
									_tmp18__length2 = self->board_length2;
									_tmp18_[(j * _tmp18__length2) + i] = (gint) 'd';
									break;
								}
								case 9499U:
								{
									gint* _tmp19_;
									gint _tmp19__length1;
									gint _tmp19__length2;
									_tmp19_ = self->board;
									_tmp19__length1 = self->board_length1;
									_tmp19__length2 = self->board_length2;
									_tmp19_[(j * _tmp19__length2) + i] = (gint) 'e';
									break;
								}
								case 9487U:
								{
									gint* _tmp20_;
									gint _tmp20__length1;
									gint _tmp20__length2;
									_tmp20_ = self->board;
									_tmp20__length1 = self->board_length1;
									_tmp20__length2 = self->board_length2;
									_tmp20_[(j * _tmp20__length2) + i] = (gint) 'f';
									break;
								}
								case 9491U:
								{
									gint* _tmp21_;
									gint _tmp21__length1;
									gint _tmp21__length2;
									_tmp21_ = self->board;
									_tmp21__length1 = self->board_length1;
									_tmp21__length2 = self->board_length2;
									_tmp21_[(j * _tmp21__length2) + i] = (gint) 'g';
									break;
								}
								case 9531U:
								{
									gint* _tmp22_;
									gint _tmp22__length1;
									gint _tmp22__length2;
									_tmp22_ = self->board;
									_tmp22__length1 = self->board_length1;
									_tmp22__length2 = self->board_length2;
									_tmp22_[(j * _tmp22__length2) + i] = (gint) 'h';
									break;
								}
								case 9507U:
								{
									gint* _tmp23_;
									gint _tmp23__length1;
									gint _tmp23__length2;
									_tmp23_ = self->board;
									_tmp23__length1 = self->board_length1;
									_tmp23__length2 = self->board_length2;
									_tmp23_[(j * _tmp23__length2) + i] = (gint) 'i';
									break;
								}
								case 9515U:
								{
									gint* _tmp24_;
									gint _tmp24__length1;
									gint _tmp24__length2;
									_tmp24_ = self->board;
									_tmp24__length1 = self->board_length1;
									_tmp24__length2 = self->board_length2;
									_tmp24_[(j * _tmp24__length2) + i] = (gint) 'j';
									break;
								}
								case 9523U:
								{
									gint* _tmp25_;
									gint _tmp25__length1;
									gint _tmp25__length2;
									_tmp25_ = self->board;
									_tmp25__length1 = self->board_length1;
									_tmp25__length2 = self->board_length2;
									_tmp25_[(j * _tmp25__length2) + i] = (gint) 'k';
									break;
								}
								case 9547U:
								{
									gint* _tmp26_;
									gint _tmp26__length1;
									gint _tmp26__length2;
									_tmp26_ = self->board;
									_tmp26__length1 = self->board_length1;
									_tmp26__length2 = self->board_length2;
									_tmp26_[(j * _tmp26__length2) + i] = (gint) 'l';
									break;
								}
								case 9650U:
								case 'm':
								{
									gint* _tmp27_;
									gint _tmp27__length1;
									gint _tmp27__length2;
									gint _tmp28_;
									_tmp27_ = self->board;
									_tmp27__length1 = self->board_length1;
									_tmp27__length2 = self->board_length2;
									_tmp27_[(j * _tmp27__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
									_tmp28_ = self->priv->_numworms;
									if (count < _tmp28_) {
										GeeLinkedList* _tmp29_;
										gpointer _tmp30_;
										Worm* _tmp31_;
										gint _tmp32_;
										_tmp29_ = self->priv->_worms;
										_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, count);
										_tmp31_ = (Worm*) _tmp30_;
										worm_set_start (_tmp31_, j, i, WORM_DIRECTION_UP);
										_g_object_unref0 (_tmp31_);
										_tmp32_ = count;
										count = _tmp32_ + 1;
									}
									break;
								}
								case 9664U:
								case 'n':
								{
									gint* _tmp33_;
									gint _tmp33__length1;
									gint _tmp33__length2;
									gint _tmp34_;
									_tmp33_ = self->board;
									_tmp33__length1 = self->board_length1;
									_tmp33__length2 = self->board_length2;
									_tmp33_[(j * _tmp33__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
									_tmp34_ = self->priv->_numworms;
									if (count < _tmp34_) {
										GeeLinkedList* _tmp35_;
										gpointer _tmp36_;
										Worm* _tmp37_;
										gint _tmp38_;
										_tmp35_ = self->priv->_worms;
										_tmp36_ = gee_abstract_list_get ((GeeAbstractList*) _tmp35_, count);
										_tmp37_ = (Worm*) _tmp36_;
										worm_set_start (_tmp37_, j, i, WORM_DIRECTION_LEFT);
										_g_object_unref0 (_tmp37_);
										_tmp38_ = count;
										count = _tmp38_ + 1;
									}
									break;
								}
								case 9660U:
								case 'o':
								{
									gint* _tmp39_;
									gint _tmp39__length1;
									gint _tmp39__length2;
									gint _tmp40_;
									_tmp39_ = self->board;
									_tmp39__length1 = self->board_length1;
									_tmp39__length2 = self->board_length2;
									_tmp39_[(j * _tmp39__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
									_tmp40_ = self->priv->_numworms;
									if (count < _tmp40_) {
										GeeLinkedList* _tmp41_;
										gpointer _tmp42_;
										Worm* _tmp43_;
										gint _tmp44_;
										_tmp41_ = self->priv->_worms;
										_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, count);
										_tmp43_ = (Worm*) _tmp42_;
										worm_set_start (_tmp43_, j, i, WORM_DIRECTION_DOWN);
										_g_object_unref0 (_tmp43_);
										_tmp44_ = count;
										count = _tmp44_ + 1;
									}
									break;
								}
								case 9654U:
								case 'p':
								{
									gint* _tmp45_;
									gint _tmp45__length1;
									gint _tmp45__length2;
									gint _tmp46_;
									_tmp45_ = self->board;
									_tmp45__length1 = self->board_length1;
									_tmp45__length2 = self->board_length2;
									_tmp45_[(j * _tmp45__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
									_tmp46_ = self->priv->_numworms;
									if (count < _tmp46_) {
										GeeLinkedList* _tmp47_;
										gpointer _tmp48_;
										Worm* _tmp49_;
										gint _tmp50_;
										_tmp47_ = self->priv->_worms;
										_tmp48_ = gee_abstract_list_get ((GeeAbstractList*) _tmp47_, count);
										_tmp49_ = (Worm*) _tmp48_;
										worm_set_start (_tmp49_, j, i, WORM_DIRECTION_RIGHT);
										_g_object_unref0 (_tmp49_);
										_tmp50_ = count;
										count = _tmp50_ + 1;
									}
									break;
								}
								case 'Q':
								case 'R':
								case 'S':
								case 'T':
								case 'U':
								case 'V':
								case 'W':
								case 'X':
								case 'Y':
								case 'Z':
								{
									gboolean _tmp51_ = FALSE;
									gint* _tmp52_;
									gint _tmp52__length1;
									gint _tmp52__length2;
									WarpManager* _tmp53_;
									gint* _tmp54_;
									gint _tmp54__length1;
									gint _tmp54__length2;
									gint _tmp55_;
									gint* _tmp56_;
									gint _tmp56__length1;
									gint _tmp56__length2;
									gint* _tmp57_;
									gint _tmp57__length1;
									gint _tmp57__length2;
									gint* _tmp58_;
									gint _tmp58__length1;
									gint _tmp58__length2;
									gint* _tmp59_;
									gint _tmp59__length1;
									gint _tmp59__length2;
									if (((gint) j) == 0) {
										_tmp51_ = TRUE;
									} else {
										_tmp51_ = ((gint) i) == 0;
									}
									if (_tmp51_) {
										result = FALSE;
										_g_free0 (tmpboard);
										return result;
									}
									_tmp52_ = self->board;
									_tmp52__length1 = self->board_length1;
									_tmp52__length2 = self->board_length2;
									_tmp52_[(j * _tmp52__length2) + i] = (gint) char_value;
									_tmp53_ = self->priv->warp_manager;
									_tmp54_ = self->board;
									_tmp54__length1 = self->board_length1;
									_tmp54__length2 = self->board_length2;
									_tmp55_ = _tmp54_[(j * _tmp54__length2) + i];
									warp_manager_add_warp_source (_tmp53_, _tmp55_, (guint8) (j - 1), (guint8) (i - 1));
									_tmp56_ = self->board;
									_tmp56__length1 = self->board_length1;
									_tmp56__length2 = self->board_length2;
									_tmp56_[((j - 1) * _tmp56__length2) + (i - 1)] = (gint) NIBBLES_GAME_WARPCHAR;
									_tmp57_ = self->board;
									_tmp57__length1 = self->board_length1;
									_tmp57__length2 = self->board_length2;
									_tmp57_[(j * _tmp57__length2) + (i - 1)] = (gint) NIBBLES_GAME_WARPCHAR;
									_tmp58_ = self->board;
									_tmp58__length1 = self->board_length1;
									_tmp58__length2 = self->board_length2;
									_tmp58_[((j - 1) * _tmp58__length2) + i] = (gint) NIBBLES_GAME_WARPCHAR;
									_tmp59_ = self->board;
									_tmp59__length1 = self->board_length1;
									_tmp59__length2 = self->board_length2;
									_tmp59_[(j * _tmp59__length2) + i] = (gint) NIBBLES_GAME_WARPCHAR;
									g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_WARP_ADDED_SIGNAL], 0, (guint8) (j - 1), (guint8) (i - 1));
									break;
								}
								case 'r':
								case 's':
								case 't':
								case 'u':
								case 'v':
								case 'w':
								case 'x':
								case 'y':
								case 'z':
								{
									WarpManager* _tmp60_;
									gint* _tmp61_;
									gint _tmp61__length1;
									gint _tmp61__length2;
									_tmp60_ = self->priv->warp_manager;
									warp_manager_add_warp_target (_tmp60_, (((gint) char_value) - ((gint) 'a')) + ((gint) 'A'), j, i);
									_tmp61_ = self->board;
									_tmp61__length1 = self->board_length1;
									_tmp61__length2 = self->board_length2;
									_tmp61_[(j * _tmp61__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
									break;
								}
								case 'a':
								case 'b':
								case 'c':
								case 'd':
								case 'e':
								case 'f':
								case 'g':
								case 'h':
								case 'i':
								case 'j':
								case 'k':
								case 'l':
								{
									gint* _tmp62_;
									gint _tmp62__length1;
									gint _tmp62__length2;
									_tmp62_ = self->board;
									_tmp62__length1 = self->board_length1;
									_tmp62__length2 = self->board_length2;
									_tmp62_[(j * _tmp62__length2) + i] = (gint) char_value;
									break;
								}
								default:
								{
									result = FALSE;
									_g_free0 (tmpboard);
									return result;
								}
							}
						}
					}
				}
			}
		}
	}
	result = TRUE;
	_g_free0 (tmpboard);
	return result;
}

static gboolean
__lambda5_ (NibblesGame* self)
{
	gboolean result;
	self->priv->bonus_cycle = (guint8) ((self->priv->bonus_cycle + 1) % 3);
	if (((gint) self->priv->bonus_cycle) == 0) {
		nibbles_game_add_bonus (self, FALSE);
	}
	result = nibbles_game_main_loop_cb (self);
	return result;
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((NibblesGame*) self);
	return result;
}

void
nibbles_game_start (NibblesGame* self,
                    gboolean add_initial_bonus)
{
	gint _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	if (add_initial_bonus) {
		nibbles_game_add_bonus (self, TRUE);
	}
	nibbles_game_set_is_running (self, TRUE);
	_tmp0_ = self->priv->_gamedelay;
	_tmp1_ = self->priv->_speed;
	self->priv->main_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (_tmp0_ * _tmp1_), ___lambda5__gsource_func, g_object_ref (self), g_object_unref);
	g_source_set_name_by_id (self->priv->main_id, "[Nibbles] main_loop_cb");
}

void
nibbles_game_stop (NibblesGame* self)
{
	g_return_if_fail (self != NULL);
	nibbles_game_set_is_running (self, FALSE);
	if (self->priv->main_id == ((guint) 0)) {
		return;
	}
	g_source_remove (self->priv->main_id);
	self->priv->main_id = (guint) 0;
}

void
nibbles_game_pause (NibblesGame* self)
{
	g_return_if_fail (self != NULL);
	nibbles_game_set_is_paused (self, TRUE);
	nibbles_game_stop (self);
}

void
nibbles_game_unpause (NibblesGame* self)
{
	g_return_if_fail (self != NULL);
	nibbles_game_set_is_paused (self, FALSE);
	nibbles_game_start (self, FALSE);
}

inline void
nibbles_game_reset (NibblesGame* self,
                    gint start_level)
{
	g_return_if_fail (self != NULL);
	nibbles_game_set_skip_score (self, start_level != 1);
	nibbles_game_set_current_level (self, start_level);
	nibbles_game_set_is_paused (self, FALSE);
}

static void
nibbles_game_end (NibblesGame* self)
{
	g_return_if_fail (self != NULL);
	nibbles_game_stop (self);
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL], 0);
}

static gboolean
_game_status_equal (const GameStatus * s1,
                    const GameStatus * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}

static gboolean
nibbles_game_main_loop_cb (NibblesGame* self)
{
	GameStatus* status = NULL;
	GameStatus* _tmp0_;
	GameStatus* _tmp1_;
	GameStatus _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = nibbles_game_get_game_status (self);
	status = _tmp0_;
	_tmp1_ = status;
	_tmp2_ = GAME_STATUS_GAMEOVER;
	if (_game_status_equal (_tmp1_, &_tmp2_) == TRUE) {
		GeeLinkedList* _tmp3_;
		gpointer _tmp4_;
		Worm* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		nibbles_game_end (self);
		_tmp3_ = self->priv->_worms;
		_tmp4_ = gee_linked_list_first (_tmp3_);
		_tmp5_ = (Worm*) _tmp4_;
		_tmp6_ = worm_get_score (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = self->priv->_current_level;
		g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp7_, _tmp8_);
		_g_object_unref0 (_tmp5_);
		result = G_SOURCE_REMOVE;
		_g_free0 (status);
		return result;
	} else {
		GameStatus* _tmp9_;
		GameStatus _tmp10_;
		_tmp9_ = status;
		_tmp10_ = GAME_STATUS_VICTORY;
		if (_game_status_equal (_tmp9_, &_tmp10_) == TRUE) {
			Worm* winner = NULL;
			Worm* _tmp11_;
			Worm* _tmp12_;
			Worm* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			nibbles_game_end (self);
			_tmp11_ = nibbles_game_get_winner (self);
			winner = _tmp11_;
			_tmp12_ = winner;
			if (_tmp12_ == NULL) {
				result = G_SOURCE_REMOVE;
				_g_object_unref0 (winner);
				_g_free0 (status);
				return result;
			}
			_tmp13_ = winner;
			_tmp14_ = worm_get_score (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = self->priv->_current_level;
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp15_, _tmp16_);
			result = G_SOURCE_REMOVE;
			_g_object_unref0 (winner);
			_g_free0 (status);
			return result;
		} else {
			GameStatus* _tmp17_;
			GameStatus _tmp18_;
			_tmp17_ = status;
			_tmp18_ = GAME_STATUS_NEWROUND;
			if (_game_status_equal (_tmp17_, &_tmp18_) == TRUE) {
				gint _tmp19_;
				gint _tmp20_;
				nibbles_game_stop (self);
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL], 0);
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL], 0);
				_tmp19_ = self->priv->_current_level;
				nibbles_game_set_current_level (self, _tmp19_ + 1);
				_tmp20_ = self->priv->_current_level;
				if (_tmp20_ == (NIBBLES_GAME_MAX_LEVEL + 1)) {
					GeeLinkedList* _tmp21_;
					gpointer _tmp22_;
					Worm* _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					_tmp21_ = self->priv->_worms;
					_tmp22_ = gee_linked_list_first (_tmp21_);
					_tmp23_ = (Worm*) _tmp22_;
					_tmp24_ = worm_get_score (_tmp23_);
					_tmp25_ = _tmp24_;
					_tmp26_ = self->priv->_current_level;
					g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp25_, _tmp26_);
					_g_object_unref0 (_tmp23_);
				}
				result = G_SOURCE_REMOVE;
				_g_free0 (status);
				return result;
			}
		}
	}
	nibbles_game_move_worms (self);
	result = G_SOURCE_CONTINUE;
	_g_free0 (status);
	return result;
}

static void
_nibbles_game_bonus_found_cb_worm_bonus_found (Worm* _sender,
                                               gpointer self)
{
	nibbles_game_bonus_found_cb ((NibblesGame*) self, _sender);
}

static void
_nibbles_game_worm_dematerialization_request_worm_finish_added (Worm* _sender,
                                                                gpointer self)
{
	nibbles_game_worm_dematerialization_request ((NibblesGame*) self, _sender);
}

void
nibbles_game_create_worms (NibblesGame* self)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_worms;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = self->priv->_numai;
	_tmp2_ = self->priv->_numhumans;
	nibbles_game_set_numworms (self, _tmp1_ + _tmp2_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				Worm* worm = NULL;
				guint8 _tmp6_;
				guint8 _tmp7_;
				Worm* _tmp8_;
				Worm* _tmp9_;
				Worm* _tmp10_;
				Worm* _tmp11_;
				gint _tmp12_;
				GeeLinkedList* _tmp13_;
				Worm* _tmp14_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = self->priv->_numworms;
				if (!(i < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->_width;
				_tmp7_ = self->priv->_height;
				_tmp8_ = worm_new (i, _tmp6_, _tmp7_);
				worm = _tmp8_;
				_tmp9_ = worm;
				g_signal_connect_object (_tmp9_, "bonus-found", (GCallback) _nibbles_game_bonus_found_cb_worm_bonus_found, self, 0);
				_tmp10_ = worm;
				g_signal_connect_object (_tmp10_, "finish-added", (GCallback) _nibbles_game_worm_dematerialization_request_worm_finish_added, self, 0);
				_tmp11_ = worm;
				_tmp12_ = self->priv->_numhumans;
				_tmp11_->is_human = i < _tmp12_;
				_tmp13_ = self->priv->_worms;
				_tmp14_ = worm;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
				_g_object_unref0 (worm);
			}
		}
	}
}

void
nibbles_game_add_worms (NibblesGame* self)
{
	g_return_if_fail (self != NULL);
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
		_tmp0_ = self->priv->_worms;
		_worm_list = _tmp0_;
		_tmp1_ = _worm_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_worm_size = _tmp3_;
		_worm_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			Worm* _tmp9_;
			gint* _tmp10_;
			gint _tmp10__length1;
			gint _tmp10__length2;
			_worm_index = _worm_index + 1;
			_tmp4_ = _worm_index;
			_tmp5_ = _worm_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _worm_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
			worm = (Worm*) _tmp7_;
			_tmp8_ = worm;
			g_signal_emit_by_name (_tmp8_, "added");
			_tmp9_ = worm;
			_tmp10_ = self->board;
			_tmp10__length1 = self->board_length1;
			_tmp10__length2 = self->board_length2;
			worm_spawn (_tmp9_, _tmp10_, (gint) _tmp10__length1, (gint) _tmp10__length2);
			_g_object_unref0 (worm);
		}
	}
}

static void
nibbles_game_move_worms (NibblesGame* self)
{
	Boni* _tmp0_;
	guint8 missed_bonuses_to_replace = 0U;
	Boni* _tmp15_;
	gint* _tmp16_;
	gint _tmp16__length1;
	gint _tmp16__length2;
	guint8 _tmp17_ = 0U;
	GeeLinkedList* dead_worms = NULL;
	GeeLinkedList* _tmp20_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->boni;
	if (boni_too_many_missed (_tmp0_)) {
		{
			GeeLinkedList* _worm_list = NULL;
			GeeLinkedList* _tmp1_;
			gint _worm_size = 0;
			GeeLinkedList* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _worm_index = 0;
			_tmp1_ = self->priv->_worms;
			_worm_list = _tmp1_;
			_tmp2_ = _worm_list;
			_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
			_tmp4_ = _tmp3_;
			_worm_size = _tmp4_;
			_worm_index = -1;
			while (TRUE) {
				gint _tmp5_;
				gint _tmp6_;
				Worm* worm = NULL;
				GeeLinkedList* _tmp7_;
				gpointer _tmp8_;
				Worm* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				_worm_index = _worm_index + 1;
				_tmp5_ = _worm_index;
				_tmp6_ = _worm_size;
				if (!(_tmp5_ < _tmp6_)) {
					break;
				}
				_tmp7_ = _worm_list;
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
				worm = (Worm*) _tmp8_;
				_tmp9_ = worm;
				_tmp10_ = worm_get_score (_tmp9_);
				_tmp11_ = _tmp10_;
				if (_tmp11_ > 0) {
					Worm* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = worm;
					_tmp13_ = worm_get_score (_tmp12_);
					_tmp14_ = _tmp13_;
					worm_set_score (_tmp12_, _tmp14_ - 1);
				}
				_g_object_unref0 (worm);
			}
		}
	}
	_tmp15_ = self->priv->boni;
	_tmp16_ = self->board;
	_tmp16__length1 = self->board_length1;
	_tmp16__length2 = self->board_length2;
	boni_on_worms_move (_tmp15_, _tmp16_, (gint) _tmp16__length1, (gint) _tmp16__length2, &_tmp17_);
	missed_bonuses_to_replace = _tmp17_;
	{
		guint8 i = 0U;
		i = (guint8) 0;
		{
			gboolean _tmp18_ = FALSE;
			_tmp18_ = TRUE;
			while (TRUE) {
				if (!_tmp18_) {
					guint8 _tmp19_;
					_tmp19_ = i;
					i = _tmp19_ + 1;
				}
				_tmp18_ = FALSE;
				if (!(i < missed_bonuses_to_replace)) {
					break;
				}
				nibbles_game_add_bonus (self, TRUE);
			}
		}
	}
	_tmp20_ = gee_linked_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	dead_worms = _tmp20_;
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp21_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gint _worm_index = 0;
		_tmp21_ = self->priv->_worms;
		_worm_list = _tmp21_;
		_tmp22_ = _worm_list;
		_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
		_tmp24_ = _tmp23_;
		_worm_size = _tmp24_;
		_worm_index = -1;
		while (TRUE) {
			gint _tmp25_;
			gint _tmp26_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp27_;
			gpointer _tmp28_;
			gboolean _tmp29_ = FALSE;
			Worm* _tmp30_;
			Worm* _tmp36_;
			_worm_index = _worm_index + 1;
			_tmp25_ = _worm_index;
			_tmp26_ = _worm_size;
			if (!(_tmp25_ < _tmp26_)) {
				break;
			}
			_tmp27_ = _worm_list;
			_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _worm_index);
			worm = (Worm*) _tmp28_;
			_tmp30_ = worm;
			if (_tmp30_->is_stopped) {
				_tmp29_ = TRUE;
			} else {
				Worm* _tmp31_;
				GeeLinkedList* _tmp32_;
				GeeLinkedList* _tmp33_;
				gboolean _tmp34_;
				gboolean _tmp35_;
				_tmp31_ = worm;
				_tmp32_ = worm_get_list (_tmp31_);
				_tmp33_ = _tmp32_;
				_tmp34_ = gee_collection_get_is_empty ((GeeCollection*) _tmp33_);
				_tmp35_ = _tmp34_;
				_tmp29_ = _tmp35_;
			}
			if (_tmp29_) {
				_g_object_unref0 (worm);
				continue;
			}
			_tmp36_ = worm;
			if (!_tmp36_->is_human) {
				Worm* _tmp37_;
				gint* _tmp38_;
				gint _tmp38__length1;
				gint _tmp38__length2;
				gint _tmp39_;
				GeeLinkedList* _tmp40_;
				_tmp37_ = worm;
				_tmp38_ = self->board;
				_tmp38__length1 = self->board_length1;
				_tmp38__length2 = self->board_length2;
				_tmp39_ = self->priv->_numworms;
				_tmp40_ = self->priv->_worms;
				worm_ai_move (_tmp37_, _tmp38_, (gint) _tmp38__length1, (gint) _tmp38__length2, _tmp39_, _tmp40_);
			}
			_g_object_unref0 (worm);
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp41_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		gint _worm_index = 0;
		_tmp41_ = self->priv->_worms;
		_worm_list = _tmp41_;
		_tmp42_ = _worm_list;
		_tmp43_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp42_);
		_tmp44_ = _tmp43_;
		_worm_size = _tmp44_;
		_worm_index = -1;
		while (TRUE) {
			gint _tmp45_;
			gint _tmp46_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp47_;
			gpointer _tmp48_;
			gboolean _tmp49_ = FALSE;
			Worm* _tmp50_;
			Position position = {0};
			Worm* _tmp56_;
			Position _tmp57_ = {0};
			guint8 target_x = 0U;
			guint8 target_y = 0U;
			gboolean _tmp58_ = FALSE;
			Worm* _tmp59_;
			WormDirection _tmp60_;
			WormDirection _tmp61_;
			WarpManager* _tmp65_;
			Position _tmp66_;
			Position _tmp67_;
			guint8 _tmp68_ = 0U;
			guint8 _tmp69_ = 0U;
			gboolean _tmp70_;
			Worm* _tmp72_;
			gint* _tmp73_;
			gint _tmp73__length1;
			gint _tmp73__length2;
			gint _tmp74_;
			Position _tmp75_;
			_worm_index = _worm_index + 1;
			_tmp45_ = _worm_index;
			_tmp46_ = _worm_size;
			if (!(_tmp45_ < _tmp46_)) {
				break;
			}
			_tmp47_ = _worm_list;
			_tmp48_ = gee_abstract_list_get ((GeeAbstractList*) _tmp47_, _worm_index);
			worm = (Worm*) _tmp48_;
			_tmp50_ = worm;
			if (_tmp50_->is_stopped) {
				_tmp49_ = TRUE;
			} else {
				Worm* _tmp51_;
				GeeLinkedList* _tmp52_;
				GeeLinkedList* _tmp53_;
				gboolean _tmp54_;
				gboolean _tmp55_;
				_tmp51_ = worm;
				_tmp52_ = worm_get_list (_tmp51_);
				_tmp53_ = _tmp52_;
				_tmp54_ = gee_collection_get_is_empty ((GeeCollection*) _tmp53_);
				_tmp55_ = _tmp54_;
				_tmp49_ = _tmp55_;
			}
			if (_tmp49_) {
				_g_object_unref0 (worm);
				continue;
			}
			_tmp56_ = worm;
			worm_position_move (_tmp56_, &_tmp57_);
			position = _tmp57_;
			_tmp59_ = worm;
			_tmp60_ = worm_get_direction (_tmp59_);
			_tmp61_ = _tmp60_;
			if (_tmp61_ == WORM_DIRECTION_LEFT) {
				_tmp58_ = TRUE;
			} else {
				Worm* _tmp62_;
				WormDirection _tmp63_;
				WormDirection _tmp64_;
				_tmp62_ = worm;
				_tmp63_ = worm_get_direction (_tmp62_);
				_tmp64_ = _tmp63_;
				_tmp58_ = _tmp64_ == WORM_DIRECTION_RIGHT;
			}
			_tmp65_ = self->priv->warp_manager;
			_tmp66_ = position;
			_tmp67_ = position;
			_tmp70_ = warp_manager_get_warp_target (_tmp65_, _tmp66_.x, _tmp67_.y, _tmp58_, &_tmp68_, &_tmp69_);
			target_x = _tmp68_;
			target_y = _tmp69_;
			if (_tmp70_) {
				Position _tmp71_ = {0};
				memset (&_tmp71_, 0, sizeof (Position));
				_tmp71_.x = target_x;
				_tmp71_.y = target_y;
				position = _tmp71_;
			}
			_tmp72_ = worm;
			_tmp73_ = self->board;
			_tmp73__length1 = self->board_length1;
			_tmp73__length2 = self->board_length2;
			_tmp74_ = self->priv->_numworms;
			_tmp75_ = position;
			if (!worm_can_move_to (_tmp72_, _tmp73_, (gint) _tmp73__length1, (gint) _tmp73__length2, _tmp74_, &_tmp75_)) {
				GeeLinkedList* _tmp76_;
				Worm* _tmp77_;
				_tmp76_ = dead_worms;
				_tmp77_ = worm;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp76_, _tmp77_);
			}
			_g_object_unref0 (worm);
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp78_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp79_;
		gint _tmp80_;
		gint _tmp81_;
		gint _worm_index = 0;
		_tmp78_ = self->priv->_worms;
		_worm_list = _tmp78_;
		_tmp79_ = _worm_list;
		_tmp80_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp79_);
		_tmp81_ = _tmp80_;
		_worm_size = _tmp81_;
		_worm_index = -1;
		while (TRUE) {
			gint _tmp82_;
			gint _tmp83_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp84_;
			gpointer _tmp85_;
			gboolean _tmp86_ = FALSE;
			gboolean _tmp87_ = FALSE;
			Worm* _tmp88_;
			Worm* _tmp96_;
			gint* _tmp97_;
			gint _tmp97__length1;
			gint _tmp97__length2;
			Worm* _tmp98_;
			Position _tmp99_ = {0};
			Position _tmp100_;
			Worm* _tmp101_;
			Position _tmp102_ = {0};
			Position _tmp103_;
			gint _tmp104_;
			_worm_index = _worm_index + 1;
			_tmp82_ = _worm_index;
			_tmp83_ = _worm_size;
			if (!(_tmp82_ < _tmp83_)) {
				break;
			}
			_tmp84_ = _worm_list;
			_tmp85_ = gee_abstract_list_get ((GeeAbstractList*) _tmp84_, _worm_index);
			worm = (Worm*) _tmp85_;
			_tmp88_ = worm;
			if (_tmp88_->is_stopped) {
				_tmp87_ = TRUE;
			} else {
				Worm* _tmp89_;
				GeeLinkedList* _tmp90_;
				GeeLinkedList* _tmp91_;
				gboolean _tmp92_;
				gboolean _tmp93_;
				_tmp89_ = worm;
				_tmp90_ = worm_get_list (_tmp89_);
				_tmp91_ = _tmp90_;
				_tmp92_ = gee_collection_get_is_empty ((GeeCollection*) _tmp91_);
				_tmp93_ = _tmp92_;
				_tmp87_ = _tmp93_;
			}
			if (_tmp87_) {
				_tmp86_ = TRUE;
			} else {
				GeeLinkedList* _tmp94_;
				Worm* _tmp95_;
				_tmp94_ = dead_worms;
				_tmp95_ = worm;
				_tmp86_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp94_, _tmp95_);
			}
			if (_tmp86_) {
				_g_object_unref0 (worm);
				continue;
			}
			_tmp96_ = worm;
			worm_move_part_1 (_tmp96_);
			_tmp97_ = self->board;
			_tmp97__length1 = self->board_length1;
			_tmp97__length2 = self->board_length2;
			_tmp98_ = worm;
			worm_get_head (_tmp98_, &_tmp99_);
			_tmp100_ = _tmp99_;
			_tmp101_ = worm;
			worm_get_head (_tmp101_, &_tmp102_);
			_tmp103_ = _tmp102_;
			_tmp104_ = _tmp97_[(_tmp100_.x * _tmp97__length2) + _tmp103_.y];
			if (_tmp104_ == ((gint) NIBBLES_GAME_WARPCHAR)) {
				guint8 target_x = 0U;
				guint8 target_y = 0U;
				gboolean _tmp105_ = FALSE;
				Worm* _tmp106_;
				WormDirection _tmp107_;
				WormDirection _tmp108_;
				WarpManager* _tmp112_;
				Worm* _tmp113_;
				Position _tmp114_ = {0};
				Position _tmp115_;
				Worm* _tmp116_;
				Position _tmp117_ = {0};
				Position _tmp118_;
				guint8 _tmp119_ = 0U;
				guint8 _tmp120_ = 0U;
				gboolean _tmp121_;
				Worm* _tmp122_;
				gint* _tmp123_;
				gint _tmp123__length1;
				gint _tmp123__length2;
				Position _tmp124_ = {0};
				_tmp106_ = worm;
				_tmp107_ = worm_get_direction (_tmp106_);
				_tmp108_ = _tmp107_;
				if (_tmp108_ == WORM_DIRECTION_LEFT) {
					_tmp105_ = TRUE;
				} else {
					Worm* _tmp109_;
					WormDirection _tmp110_;
					WormDirection _tmp111_;
					_tmp109_ = worm;
					_tmp110_ = worm_get_direction (_tmp109_);
					_tmp111_ = _tmp110_;
					_tmp105_ = _tmp111_ == WORM_DIRECTION_RIGHT;
				}
				_tmp112_ = self->priv->warp_manager;
				_tmp113_ = worm;
				worm_get_head (_tmp113_, &_tmp114_);
				_tmp115_ = _tmp114_;
				_tmp116_ = worm;
				worm_get_head (_tmp116_, &_tmp117_);
				_tmp118_ = _tmp117_;
				_tmp121_ = warp_manager_get_warp_target (_tmp112_, _tmp115_.x, _tmp118_.y, _tmp105_, &_tmp119_, &_tmp120_);
				target_x = _tmp119_;
				target_y = _tmp120_;
				if (!_tmp121_) {
					g_assert_not_reached ();
				}
				_tmp122_ = worm;
				_tmp123_ = self->board;
				_tmp123__length1 = self->board_length1;
				_tmp123__length2 = self->board_length2;
				memset (&_tmp124_, 0, sizeof (Position));
				_tmp124_.x = target_x;
				_tmp124_.y = target_y;
				worm_move_part_2 (_tmp122_, _tmp123_, (gint) _tmp123__length1, (gint) _tmp123__length2, &_tmp124_);
			} else {
				Worm* _tmp125_;
				gint* _tmp126_;
				gint _tmp126__length1;
				gint _tmp126__length2;
				_tmp125_ = worm;
				_tmp126_ = self->board;
				_tmp126__length1 = self->board_length1;
				_tmp126__length2 = self->board_length2;
				worm_move_part_2 (_tmp125_, _tmp126_, (gint) _tmp126__length1, (gint) _tmp126__length2, NULL);
			}
			{
				GeeLinkedList* _other_worm_list = NULL;
				GeeLinkedList* _tmp127_;
				gint _other_worm_size = 0;
				GeeLinkedList* _tmp128_;
				gint _tmp129_;
				gint _tmp130_;
				gint _other_worm_index = 0;
				_tmp127_ = self->priv->_worms;
				_other_worm_list = _tmp127_;
				_tmp128_ = _other_worm_list;
				_tmp129_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp128_);
				_tmp130_ = _tmp129_;
				_other_worm_size = _tmp130_;
				_other_worm_index = -1;
				while (TRUE) {
					gint _tmp131_;
					gint _tmp132_;
					Worm* other_worm = NULL;
					GeeLinkedList* _tmp133_;
					gpointer _tmp134_;
					gboolean _tmp135_ = FALSE;
					gboolean _tmp136_ = FALSE;
					gboolean _tmp137_ = FALSE;
					gboolean _tmp138_ = FALSE;
					Worm* _tmp139_;
					Worm* _tmp140_;
					_other_worm_index = _other_worm_index + 1;
					_tmp131_ = _other_worm_index;
					_tmp132_ = _other_worm_size;
					if (!(_tmp131_ < _tmp132_)) {
						break;
					}
					_tmp133_ = _other_worm_list;
					_tmp134_ = gee_abstract_list_get ((GeeAbstractList*) _tmp133_, _other_worm_index);
					other_worm = (Worm*) _tmp134_;
					_tmp139_ = worm;
					_tmp140_ = other_worm;
					if (_tmp139_ != _tmp140_) {
						Worm* _tmp141_;
						_tmp141_ = other_worm;
						_tmp138_ = !_tmp141_->is_stopped;
					} else {
						_tmp138_ = FALSE;
					}
					if (_tmp138_) {
						Worm* _tmp142_;
						GeeLinkedList* _tmp143_;
						GeeLinkedList* _tmp144_;
						gboolean _tmp145_;
						gboolean _tmp146_;
						_tmp142_ = other_worm;
						_tmp143_ = worm_get_list (_tmp142_);
						_tmp144_ = _tmp143_;
						_tmp145_ = gee_collection_get_is_empty ((GeeCollection*) _tmp144_);
						_tmp146_ = _tmp145_;
						_tmp137_ = !_tmp146_;
					} else {
						_tmp137_ = FALSE;
					}
					if (_tmp137_) {
						Worm* _tmp147_;
						Position _tmp148_ = {0};
						Position _tmp149_;
						Worm* _tmp150_;
						Position _tmp151_ = {0};
						Position _tmp152_;
						_tmp147_ = worm;
						worm_get_head (_tmp147_, &_tmp148_);
						_tmp149_ = _tmp148_;
						_tmp150_ = other_worm;
						worm_get_head (_tmp150_, &_tmp151_);
						_tmp152_ = _tmp151_;
						_tmp136_ = _tmp149_.x == _tmp152_.x;
					} else {
						_tmp136_ = FALSE;
					}
					if (_tmp136_) {
						Worm* _tmp153_;
						Position _tmp154_ = {0};
						Position _tmp155_;
						Worm* _tmp156_;
						Position _tmp157_ = {0};
						Position _tmp158_;
						_tmp153_ = worm;
						worm_get_head (_tmp153_, &_tmp154_);
						_tmp155_ = _tmp154_;
						_tmp156_ = other_worm;
						worm_get_head (_tmp156_, &_tmp157_);
						_tmp158_ = _tmp157_;
						_tmp135_ = _tmp155_.y == _tmp158_.y;
					} else {
						_tmp135_ = FALSE;
					}
					if (_tmp135_) {
						GeeLinkedList* _tmp159_;
						Worm* _tmp160_;
						GeeLinkedList* _tmp163_;
						Worm* _tmp164_;
						_tmp159_ = dead_worms;
						_tmp160_ = worm;
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp159_, _tmp160_)) {
							GeeLinkedList* _tmp161_;
							Worm* _tmp162_;
							_tmp161_ = dead_worms;
							_tmp162_ = worm;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp161_, _tmp162_);
						}
						_tmp163_ = dead_worms;
						_tmp164_ = other_worm;
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp163_, _tmp164_)) {
							GeeLinkedList* _tmp165_;
							Worm* _tmp166_;
							_tmp165_ = dead_worms;
							_tmp166_ = other_worm;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp165_, _tmp166_);
						}
					}
					_g_object_unref0 (other_worm);
				}
			}
			_g_object_unref0 (worm);
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp167_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp168_;
		gint _tmp169_;
		gint _tmp170_;
		gint _worm_index = 0;
		_tmp167_ = dead_worms;
		_worm_list = _tmp167_;
		_tmp168_ = _worm_list;
		_tmp169_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp168_);
		_tmp170_ = _tmp169_;
		_worm_size = _tmp170_;
		_worm_index = -1;
		while (TRUE) {
			gint _tmp171_;
			gint _tmp172_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp173_;
			gpointer _tmp174_;
			gint _tmp175_;
			Worm* _tmp180_;
			guint8 _tmp181_;
			guint8 _tmp182_;
			_worm_index = _worm_index + 1;
			_tmp171_ = _worm_index;
			_tmp172_ = _worm_size;
			if (!(_tmp171_ < _tmp172_)) {
				break;
			}
			_tmp173_ = _worm_list;
			_tmp174_ = gee_abstract_list_get ((GeeAbstractList*) _tmp173_, _worm_index);
			worm = (Worm*) _tmp174_;
			_tmp175_ = self->priv->_numworms;
			if (_tmp175_ > 1) {
				Worm* _tmp176_;
				Worm* _tmp177_;
				gint _tmp178_;
				gint _tmp179_;
				_tmp176_ = worm;
				_tmp177_ = worm;
				_tmp178_ = worm_get_score (_tmp177_);
				_tmp179_ = _tmp178_;
				worm_set_score (_tmp176_, (_tmp179_ * 7) / 10);
			}
			_tmp180_ = worm;
			_tmp181_ = worm_get_lives (_tmp180_);
			_tmp182_ = _tmp181_;
			if (((gint) _tmp182_) > 0) {
				Worm* _tmp183_;
				gint* _tmp184_;
				gint _tmp184__length1;
				gint _tmp184__length2;
				_tmp183_ = worm;
				_tmp184_ = self->board;
				_tmp184__length1 = self->board_length1;
				_tmp184__length2 = self->board_length2;
				worm_reset (_tmp183_, _tmp184_, (gint) _tmp184__length1, (gint) _tmp184__length2);
			}
			_g_object_unref0 (worm);
		}
	}
	_g_object_unref0 (dead_worms);
}

static void
nibbles_game_reverse_worms (NibblesGame* self,
                            Worm* worm)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (worm != NULL);
	{
		GeeLinkedList* _other_worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _other_worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _other_worm_index = 0;
		_tmp0_ = self->priv->_worms;
		_other_worm_list = _tmp0_;
		_tmp1_ = _other_worm_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_other_worm_size = _tmp3_;
		_other_worm_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			Worm* other_worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			_other_worm_index = _other_worm_index + 1;
			_tmp4_ = _other_worm_index;
			_tmp5_ = _other_worm_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _other_worm_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _other_worm_index);
			other_worm = (Worm*) _tmp7_;
			_tmp8_ = other_worm;
			if (worm != _tmp8_) {
				Worm* _tmp9_;
				gint* _tmp10_;
				gint _tmp10__length1;
				gint _tmp10__length2;
				_tmp9_ = other_worm;
				_tmp10_ = self->board;
				_tmp10__length1 = self->board_length1;
				_tmp10__length2 = self->board_length2;
				worm_reverse (_tmp9_, _tmp10_, (gint) _tmp10__length1, (gint) _tmp10__length2);
			}
			_g_object_unref0 (other_worm);
		}
	}
}

static void
nibbles_game_worm_dematerialization_request (NibblesGame* self,
                                             Worm* worm)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (worm != NULL);
	_tmp0_ = self->board;
	_tmp0__length1 = self->board_length1;
	_tmp0__length2 = self->board_length2;
	_tmp1_ = self->priv->_gamedelay;
	worm_dematerialize (worm, _tmp0_, (gint) _tmp0__length1, (gint) _tmp0__length2, 3, _tmp1_);
}

static void
nibbles_game_add_bonus (NibblesGame* self,
                        gboolean regular)
{
	gboolean good = FALSE;
	guint8 x = 0U;
	guint8 y = 0U;
	g_return_if_fail (self != NULL);
	good = FALSE;
	x = (guint8) 0;
	y = (guint8) 0;
	if (!regular) {
		if (g_random_int_range ((gint32) 0, (gint32) 50) != ((gint32) 0)) {
			return;
		}
	}
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			guint8 _tmp1_;
			guint8 _tmp2_;
			gint* _tmp3_;
			gint _tmp3__length1;
			gint _tmp3__length2;
			gint _tmp4_;
			gint* _tmp5_;
			gint _tmp5__length1;
			gint _tmp5__length2;
			gint _tmp6_;
			gint* _tmp7_;
			gint _tmp7__length1;
			gint _tmp7__length2;
			gint _tmp8_;
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			gint _tmp10_;
			if (!_tmp0_) {
				if (!(!good)) {
					break;
				}
			}
			_tmp0_ = FALSE;
			good = TRUE;
			_tmp1_ = self->priv->_width;
			x = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp1_ - 1));
			_tmp2_ = self->priv->_height;
			y = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp2_ - 1));
			_tmp3_ = self->board;
			_tmp3__length1 = self->board_length1;
			_tmp3__length2 = self->board_length2;
			_tmp4_ = _tmp3_[(x * _tmp3__length2) + y];
			if (_tmp4_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				good = FALSE;
				continue;
			}
			_tmp5_ = self->board;
			_tmp5__length1 = self->board_length1;
			_tmp5__length2 = self->board_length2;
			_tmp6_ = _tmp5_[((x + 1) * _tmp5__length2) + (y + 1)];
			if (_tmp6_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				good = FALSE;
				continue;
			}
			_tmp7_ = self->board;
			_tmp7__length1 = self->board_length1;
			_tmp7__length2 = self->board_length2;
			_tmp8_ = _tmp7_[((x + 1) * _tmp7__length2) + y];
			if (_tmp8_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				good = FALSE;
				continue;
			}
			_tmp9_ = self->board;
			_tmp9__length1 = self->board_length1;
			_tmp9__length2 = self->board_length2;
			_tmp10_ = _tmp9_[(x * _tmp9__length2) + (y + 1)];
			if (_tmp10_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				good = FALSE;
				continue;
			}
		}
	}
	if (regular) {
		gboolean _tmp11_ = FALSE;
		if (g_random_int_range ((gint32) 0, (gint32) 7) == ((gint32) 0)) {
			gboolean _tmp12_;
			_tmp12_ = self->priv->_fakes;
			_tmp11_ = _tmp12_;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REGULAR, TRUE, (guint16) 300);
		}
		good = FALSE;
		while (TRUE) {
			guint8 _tmp13_;
			guint8 _tmp14_;
			gint* _tmp15_;
			gint _tmp15__length1;
			gint _tmp15__length2;
			gint _tmp16_;
			gint* _tmp17_;
			gint _tmp17__length1;
			gint _tmp17__length2;
			gint _tmp18_;
			gint* _tmp19_;
			gint _tmp19__length1;
			gint _tmp19__length2;
			gint _tmp20_;
			gint* _tmp21_;
			gint _tmp21__length1;
			gint _tmp21__length2;
			gint _tmp22_;
			if (!(!good)) {
				break;
			}
			good = TRUE;
			_tmp13_ = self->priv->_width;
			x = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp13_ - 1));
			_tmp14_ = self->priv->_height;
			y = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp14_ - 1));
			_tmp15_ = self->board;
			_tmp15__length1 = self->board_length1;
			_tmp15__length2 = self->board_length2;
			_tmp16_ = _tmp15_[(x * _tmp15__length2) + y];
			if (_tmp16_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				good = FALSE;
				continue;
			}
			_tmp17_ = self->board;
			_tmp17__length1 = self->board_length1;
			_tmp17__length2 = self->board_length2;
			_tmp18_ = _tmp17_[((x + 1) * _tmp17__length2) + (y + 1)];
			if (_tmp18_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				good = FALSE;
				continue;
			}
			_tmp19_ = self->board;
			_tmp19__length1 = self->board_length1;
			_tmp19__length2 = self->board_length2;
			_tmp20_ = _tmp19_[((x + 1) * _tmp19__length2) + y];
			if (_tmp20_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				good = FALSE;
				continue;
			}
			_tmp21_ = self->board;
			_tmp21__length1 = self->board_length1;
			_tmp21__length2 = self->board_length2;
			_tmp22_ = _tmp21_[(x * _tmp21__length2) + (y + 1)];
			if (_tmp22_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				good = FALSE;
				continue;
			}
		}
		_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REGULAR, FALSE, (guint16) 300);
	} else {
		Boni* _tmp23_;
		_tmp23_ = self->priv->boni;
		if (!boni_too_many_missed (_tmp23_)) {
			gboolean _tmp24_ = FALSE;
			if (g_random_int_range ((gint32) 0, (gint32) 7) != ((gint32) 0)) {
				good = FALSE;
			} else {
				good = TRUE;
			}
			if (good) {
				gboolean _tmp25_;
				_tmp25_ = self->priv->_fakes;
				_tmp24_ = !_tmp25_;
			} else {
				_tmp24_ = FALSE;
			}
			if (_tmp24_) {
				return;
			}
			switch (g_random_int_range ((gint32) 0, (gint32) 21)) {
				case 0:
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 6:
				case 7:
				case 8:
				case 9:
				{
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_HALF, good, (guint16) 200);
					break;
				}
				case 10:
				case 11:
				case 12:
				case 13:
				case 14:
				{
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_DOUBLE, good, (guint16) 150);
					break;
				}
				case 15:
				{
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_LIFE, good, (guint16) 100);
					break;
				}
				case 16:
				case 17:
				case 18:
				case 19:
				case 20:
				{
					gint _tmp26_;
					_tmp26_ = self->priv->_numworms;
					if (_tmp26_ > 1) {
						_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REVERSE, good, (guint16) 150);
					}
					break;
				}
				default:
				break;
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static inline void
_nibbles_game_add_bonus (NibblesGame* self,
                         guint8 x,
                         guint8 y,
                         BonusType bonus_type,
                         gboolean fake,
                         guint16 countdown)
{
	Bonus* bonus = NULL;
	Bonus* _tmp0_;
	Boni* _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Bonus* _tmp3_;
	Bonus* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = bonus_new (x, y, bonus_type, fake, countdown);
	bonus = _tmp0_;
	_tmp1_ = self->priv->boni;
	_tmp2_ = self->board;
	_tmp2__length1 = self->board_length1;
	_tmp2__length2 = self->board_length2;
	_tmp3_ = bonus;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	if (boni_add_bonus (_tmp1_, _tmp2_, (gint) _tmp2__length1, (gint) _tmp2__length2, _tmp4_)) {
		Bonus* _tmp5_;
		_tmp5_ = bonus;
		g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_ADDED_SIGNAL], 0, _tmp5_);
	}
	_g_object_unref0 (bonus);
}

static void
nibbles_game_apply_bonus (NibblesGame* self,
                          Bonus* bonus,
                          Worm* worm)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	Position _tmp4_ = {0};
	Position _tmp5_;
	Position _tmp6_ = {0};
	Position _tmp7_;
	gint _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (bonus != NULL);
	g_return_if_fail (worm != NULL);
	_tmp0_ = bonus_get_fake (bonus);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gint* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		_tmp2_ = self->board;
		_tmp2__length1 = self->board_length1;
		_tmp2__length2 = self->board_length2;
		worm_reverse (worm, _tmp2_, (gint) _tmp2__length1, (gint) _tmp2__length2);
		return;
	}
	_tmp3_ = self->board;
	_tmp3__length1 = self->board_length1;
	_tmp3__length2 = self->board_length2;
	worm_get_head (worm, &_tmp4_);
	_tmp5_ = _tmp4_;
	worm_get_head (worm, &_tmp6_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _tmp3_[(_tmp5_.x * _tmp3__length2) + _tmp7_.y];
	switch (_tmp8_ - 'A') {
		case BONUS_TYPE_REGULAR:
		{
			guint8 nth_bonus = 0U;
			Boni* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			_tmp9_ = self->priv->boni;
			nth_bonus = boni_new_regular_bonus_eaten (_tmp9_);
			_tmp10_ = worm_get_change (worm);
			_tmp11_ = _tmp10_;
			worm_set_change (worm, _tmp11_ + (((gint) nth_bonus) * WORM_GROW_FACTOR));
			_tmp12_ = worm_get_score (worm);
			_tmp13_ = _tmp12_;
			_tmp14_ = self->priv->_current_level;
			worm_set_score (worm, _tmp13_ + (((gint) nth_bonus) * _tmp14_));
			break;
		}
		case BONUS_TYPE_DOUBLE:
		{
			gint _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			gint _tmp27_;
			_tmp15_ = worm_get_score (worm);
			_tmp16_ = _tmp15_;
			_tmp17_ = worm_get_length (worm);
			_tmp18_ = _tmp17_;
			_tmp19_ = worm_get_change (worm);
			_tmp20_ = _tmp19_;
			_tmp21_ = self->priv->_current_level;
			worm_set_score (worm, _tmp16_ + ((_tmp18_ + _tmp20_) * _tmp21_));
			_tmp22_ = worm_get_change (worm);
			_tmp23_ = _tmp22_;
			_tmp24_ = worm_get_length (worm);
			_tmp25_ = _tmp24_;
			_tmp26_ = worm_get_change (worm);
			_tmp27_ = _tmp26_;
			worm_set_change (worm, _tmp23_ + (_tmp25_ + _tmp27_));
			break;
		}
		case BONUS_TYPE_HALF:
		{
			gint _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
			_tmp28_ = worm_get_length (worm);
			_tmp29_ = _tmp28_;
			_tmp30_ = worm_get_change (worm);
			_tmp31_ = _tmp30_;
			if ((_tmp29_ + _tmp31_) > 2) {
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint* _tmp39_;
				gint _tmp39__length1;
				gint _tmp39__length2;
				gint _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				gint _tmp45_;
				gint _tmp46_;
				gint _tmp47_;
				_tmp32_ = worm_get_score (worm);
				_tmp33_ = _tmp32_;
				_tmp34_ = worm_get_length (worm);
				_tmp35_ = _tmp34_;
				_tmp36_ = worm_get_change (worm);
				_tmp37_ = _tmp36_;
				_tmp38_ = self->priv->_current_level;
				worm_set_score (worm, _tmp33_ + ((_tmp35_ + (_tmp37_ / 2)) * _tmp38_));
				_tmp39_ = self->board;
				_tmp39__length1 = self->board_length1;
				_tmp39__length2 = self->board_length2;
				_tmp40_ = worm_get_length (worm);
				_tmp41_ = _tmp40_;
				worm_reduce_tail (worm, _tmp39_, (gint) _tmp39__length1, (gint) _tmp39__length2, _tmp41_ / 2);
				_tmp42_ = worm_get_change (worm);
				_tmp43_ = _tmp42_;
				_tmp44_ = worm_get_length (worm);
				_tmp45_ = _tmp44_;
				_tmp46_ = worm_get_change (worm);
				_tmp47_ = _tmp46_;
				worm_set_change (worm, _tmp43_ - ((_tmp45_ + _tmp47_) / 2));
			}
			break;
		}
		case BONUS_TYPE_LIFE:
		{
			worm_add_life (worm);
			break;
		}
		case BONUS_TYPE_REVERSE:
		{
			nibbles_game_reverse_worms (self, worm);
			break;
		}
		default:
		break;
	}
}

static void
nibbles_game_bonus_found_cb (NibblesGame* self,
                             Worm* worm)
{
	Bonus* bonus = NULL;
	Boni* _tmp0_;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	Position _tmp2_ = {0};
	Position _tmp3_;
	Position _tmp4_ = {0};
	Position _tmp5_;
	Bonus* _tmp6_;
	Bonus* _tmp7_;
	Bonus* _tmp8_;
	Bonus* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gint* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	Position _tmp12_ = {0};
	Position _tmp13_;
	Position _tmp14_ = {0};
	Position _tmp15_;
	gint _tmp16_;
	gboolean real_bonus = FALSE;
	Boni* _tmp20_;
	gint* _tmp21_;
	gint _tmp21__length1;
	gint _tmp21__length2;
	Bonus* _tmp22_;
	gboolean _tmp23_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (worm != NULL);
	_tmp0_ = self->priv->boni;
	_tmp1_ = self->board;
	_tmp1__length1 = self->board_length1;
	_tmp1__length2 = self->board_length2;
	worm_get_head (worm, &_tmp2_);
	_tmp3_ = _tmp2_;
	worm_get_head (worm, &_tmp4_);
	_tmp5_ = _tmp4_;
	_tmp6_ = boni_get_bonus (_tmp0_, _tmp1_, (gint) _tmp1__length1, (gint) _tmp1__length2, _tmp3_.x, _tmp5_.y);
	bonus = _tmp6_;
	_tmp7_ = bonus;
	if (_tmp7_ == NULL) {
		_g_object_unref0 (bonus);
		return;
	}
	_tmp8_ = bonus;
	nibbles_game_apply_bonus (self, _tmp8_, worm);
	_tmp9_ = bonus;
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_APPLIED_SIGNAL], 0, _tmp9_, worm);
	_tmp11_ = self->board;
	_tmp11__length1 = self->board_length1;
	_tmp11__length2 = self->board_length2;
	worm_get_head (worm, &_tmp12_);
	_tmp13_ = _tmp12_;
	worm_get_head (worm, &_tmp14_);
	_tmp15_ = _tmp14_;
	_tmp16_ = _tmp11_[(_tmp13_.x * _tmp11__length2) + _tmp15_.y];
	if (_tmp16_ == ((gint) (BONUS_TYPE_REGULAR + 'A'))) {
		Bonus* _tmp17_;
		gboolean _tmp18_;
		gboolean _tmp19_;
		_tmp17_ = bonus;
		_tmp18_ = bonus_get_fake (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp10_ = !_tmp19_;
	} else {
		_tmp10_ = FALSE;
	}
	real_bonus = _tmp10_;
	_tmp20_ = self->priv->boni;
	_tmp21_ = self->board;
	_tmp21__length1 = self->board_length1;
	_tmp21__length2 = self->board_length2;
	_tmp22_ = bonus;
	boni_remove_bonus (_tmp20_, _tmp21_, (gint) _tmp21__length1, (gint) _tmp21__length2, _tmp22_);
	if (real_bonus) {
		Boni* _tmp24_;
		_tmp24_ = self->priv->boni;
		_tmp23_ = !boni_last_regular_bonus (_tmp24_);
	} else {
		_tmp23_ = FALSE;
	}
	if (_tmp23_) {
		nibbles_game_add_bonus (self, TRUE);
	}
	_g_object_unref0 (bonus);
}

static GameStatus*
_game_status_dup (GameStatus* self)
{
	GameStatus* dup;
	dup = g_new0 (GameStatus, 1);
	memcpy (dup, self, sizeof (GameStatus));
	return dup;
}

static gpointer
__game_status_dup0 (gpointer self)
{
	return self ? _game_status_dup (self) : NULL;
}

GameStatus*
nibbles_game_get_game_status (NibblesGame* self)
{
	gint worms_left = 0;
	gboolean _tmp25_ = FALSE;
	Boni* _tmp31_;
	GameStatus* result;
	g_return_val_if_fail (self != NULL, NULL);
	worms_left = 0;
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
		_tmp0_ = self->priv->_worms;
		_worm_list = _tmp0_;
		_tmp1_ = _worm_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_worm_size = _tmp3_;
		_worm_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			guint8 _tmp9_;
			guint8 _tmp10_;
			_worm_index = _worm_index + 1;
			_tmp4_ = _worm_index;
			_tmp5_ = _worm_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _worm_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
			worm = (Worm*) _tmp7_;
			_tmp8_ = worm;
			_tmp9_ = worm_get_lives (_tmp8_);
			_tmp10_ = _tmp9_;
			if (((gint) _tmp10_) > 0) {
				worms_left += 1;
			} else {
				gboolean _tmp11_ = FALSE;
				Worm* _tmp12_;
				_tmp12_ = worm;
				if (_tmp12_->is_human) {
					Worm* _tmp13_;
					guint8 _tmp14_;
					guint8 _tmp15_;
					_tmp13_ = worm;
					_tmp14_ = worm_get_lives (_tmp13_);
					_tmp15_ = _tmp14_;
					_tmp11_ = ((gint) _tmp15_) == 0;
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					GameStatus _tmp16_;
					GameStatus* _tmp17_;
					_tmp16_ = GAME_STATUS_GAMEOVER;
					_tmp17_ = __game_status_dup0 (&_tmp16_);
					result = _tmp17_;
					_g_object_unref0 (worm);
					return result;
				} else {
					gboolean _tmp18_ = FALSE;
					gint _tmp19_;
					_tmp19_ = self->priv->_numhumans;
					if (_tmp19_ == 0) {
						Worm* _tmp20_;
						guint8 _tmp21_;
						guint8 _tmp22_;
						_tmp20_ = worm;
						_tmp21_ = worm_get_lives (_tmp20_);
						_tmp22_ = _tmp21_;
						_tmp18_ = ((gint) _tmp22_) == 0;
					} else {
						_tmp18_ = FALSE;
					}
					if (_tmp18_) {
						GameStatus _tmp23_;
						GameStatus* _tmp24_;
						_tmp23_ = GAME_STATUS_GAMEOVER;
						_tmp24_ = __game_status_dup0 (&_tmp23_);
						result = _tmp24_;
						_g_object_unref0 (worm);
						return result;
					}
				}
			}
			_g_object_unref0 (worm);
		}
	}
	if (worms_left == 1) {
		gint _tmp26_;
		_tmp26_ = self->priv->_numworms;
		_tmp25_ = _tmp26_ > 1;
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		GameStatus _tmp27_;
		GameStatus* _tmp28_;
		_tmp27_ = GAME_STATUS_VICTORY;
		_tmp28_ = __game_status_dup0 (&_tmp27_);
		result = _tmp28_;
		return result;
	} else {
		if (worms_left == 0) {
			GameStatus _tmp29_;
			GameStatus* _tmp30_;
			_tmp29_ = GAME_STATUS_GAMEOVER;
			_tmp30_ = __game_status_dup0 (&_tmp29_);
			result = _tmp30_;
			return result;
		}
	}
	_tmp31_ = self->priv->boni;
	if (boni_last_regular_bonus (_tmp31_)) {
		GameStatus _tmp32_;
		GameStatus* _tmp33_;
		_tmp32_ = GAME_STATUS_NEWROUND;
		_tmp33_ = __game_status_dup0 (&_tmp32_);
		result = _tmp33_;
		return result;
	}
	result = NULL;
	return result;
}

Worm*
nibbles_game_get_winner (NibblesGame* self)
{
	Worm* result;
	g_return_val_if_fail (self != NULL, NULL);
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
		_tmp0_ = self->priv->_worms;
		_worm_list = _tmp0_;
		_tmp1_ = _worm_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_worm_size = _tmp3_;
		_worm_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			guint8 _tmp9_;
			guint8 _tmp10_;
			_worm_index = _worm_index + 1;
			_tmp4_ = _worm_index;
			_tmp5_ = _worm_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _worm_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
			worm = (Worm*) _tmp7_;
			_tmp8_ = worm;
			_tmp9_ = worm_get_lives (_tmp8_);
			_tmp10_ = _tmp9_;
			if (((gint) _tmp10_) > 0) {
				result = worm;
				return result;
			}
			_g_object_unref0 (worm);
		}
	}
	result = NULL;
	return result;
}

static gboolean
____lambda6_ (GValue* prop_value,
              GVariant* variant)
{
	const gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (prop_value != NULL, FALSE);
	g_return_val_if_fail (variant != NULL, FALSE);
	_tmp0_ = g_variant_get_string (variant, NULL);
	g_value_set_int (prop_value, nibbles_game_get_color_num (_tmp0_));
	result = TRUE;
	return result;
}

static gboolean
_____lambda6__gsettings_bind_get_mapping (GValue* value,
                                          GVariant* variant,
                                          void* user_data)
{
	gboolean result;
	result = ____lambda6_ (value, variant);
	return result;
}

static GVariant*
____lambda7_ (GValue* prop_value,
              const GVariantType* variant_type)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* result;
	g_return_val_if_fail (prop_value != NULL, NULL);
	g_return_val_if_fail (variant_type != NULL, NULL);
	_tmp0_ = nibbles_game_get_color_string (g_value_get_int (prop_value));
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_new_string (_tmp1_);
	g_variant_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}

static GVariant*
_____lambda7__gsettings_bind_set_mapping (GValue* value,
                                          const GVariantType* expected_type,
                                          void* user_data)
{
	GVariant* result;
	result = ____lambda7_ (value, expected_type);
	return result;
}

void
nibbles_game_load_worm_properties (NibblesGame* self,
                                   GeeArrayList* worm_settings)
{
	GeeHashMap* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (worm_settings != NULL);
	_tmp0_ = self->priv->_worm_props;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
		_tmp1_ = self->priv->_worms;
		_worm_list = _tmp1_;
		_tmp2_ = _worm_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_worm_size = _tmp4_;
		_worm_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			WormProperties* properties = NULL;
			WormProperties* _tmp9_;
			Worm* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_;
			GSettings* _tmp14_;
			WormProperties* _tmp15_;
			Worm* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gpointer _tmp19_;
			GSettings* _tmp20_;
			WormProperties* _tmp21_;
			Worm* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			gpointer _tmp25_;
			GSettings* _tmp26_;
			WormProperties* _tmp27_;
			Worm* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gpointer _tmp31_;
			GSettings* _tmp32_;
			WormProperties* _tmp33_;
			Worm* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			gpointer _tmp37_;
			GSettings* _tmp38_;
			WormProperties* _tmp39_;
			GeeHashMap* _tmp40_;
			Worm* _tmp41_;
			WormProperties* _tmp42_;
			_worm_index = _worm_index + 1;
			_tmp5_ = _worm_index;
			_tmp6_ = _worm_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _worm_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
			worm = (Worm*) _tmp8_;
			_tmp9_ = worm_properties_new ();
			properties = _tmp9_;
			_tmp10_ = worm;
			_tmp11_ = worm_get_id (_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp12_);
			_tmp14_ = (GSettings*) _tmp13_;
			_tmp15_ = properties;
			g_settings_bind_with_mapping (_tmp14_, "color", (GObject*) _tmp15_, "color", G_SETTINGS_BIND_DEFAULT, _____lambda6__gsettings_bind_get_mapping, _____lambda7__gsettings_bind_set_mapping, NULL, NULL);
			_g_object_unref0 (_tmp14_);
			_tmp16_ = worm;
			_tmp17_ = worm_get_id (_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp18_);
			_tmp20_ = (GSettings*) _tmp19_;
			_tmp21_ = properties;
			g_settings_bind (_tmp20_, "key-up", (GObject*) _tmp21_, "up", G_SETTINGS_BIND_DEFAULT);
			_g_object_unref0 (_tmp20_);
			_tmp22_ = worm;
			_tmp23_ = worm_get_id (_tmp22_);
			_tmp24_ = _tmp23_;
			_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp24_);
			_tmp26_ = (GSettings*) _tmp25_;
			_tmp27_ = properties;
			g_settings_bind (_tmp26_, "key-down", (GObject*) _tmp27_, "down", G_SETTINGS_BIND_DEFAULT);
			_g_object_unref0 (_tmp26_);
			_tmp28_ = worm;
			_tmp29_ = worm_get_id (_tmp28_);
			_tmp30_ = _tmp29_;
			_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp30_);
			_tmp32_ = (GSettings*) _tmp31_;
			_tmp33_ = properties;
			g_settings_bind (_tmp32_, "key-left", (GObject*) _tmp33_, "left", G_SETTINGS_BIND_DEFAULT);
			_g_object_unref0 (_tmp32_);
			_tmp34_ = worm;
			_tmp35_ = worm_get_id (_tmp34_);
			_tmp36_ = _tmp35_;
			_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp36_);
			_tmp38_ = (GSettings*) _tmp37_;
			_tmp39_ = properties;
			g_settings_bind (_tmp38_, "key-right", (GObject*) _tmp39_, "right", G_SETTINGS_BIND_DEFAULT);
			_g_object_unref0 (_tmp38_);
			_tmp40_ = self->priv->_worm_props;
			_tmp41_ = worm;
			_tmp42_ = properties;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp40_, _tmp41_, _tmp42_);
			_g_object_unref0 (properties);
			_g_object_unref0 (worm);
		}
	}
}

static inline gchar*
nibbles_game_get_color_string (gint color)
{
	gchar* result;
	switch (color) {
		case 0:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("red");
			result = _tmp0_;
			return result;
		}
		case 1:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("green");
			result = _tmp1_;
			return result;
		}
		case 2:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("blue");
			result = _tmp2_;
			return result;
		}
		case 3:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("yellow");
			result = _tmp3_;
			return result;
		}
		case 4:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("cyan");
			result = _tmp4_;
			return result;
		}
		case 5:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("purple");
			result = _tmp5_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static inline gint
nibbles_game_get_color_num (const gchar* color)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	static GQuark _tmp1_label5 = 0;
	gint result;
	g_return_val_if_fail (color != NULL, 0);
	_tmp0_ = color;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("red")))) {
		switch (0) {
			default:
			{
				result = 0;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("green")))) {
		switch (0) {
			default:
			{
				result = 1;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("blue")))) {
		switch (0) {
			default:
			{
				result = 2;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("yellow")))) {
		switch (0) {
			default:
			{
				result = 3;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("cyan")))) {
		switch (0) {
			default:
			{
				result = 4;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("purple")))) {
		switch (0) {
			default:
			{
				result = 5;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
}

gboolean
nibbles_game_handle_keypress (NibblesGame* self,
                              guint keyval)
{
	gboolean _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_running;
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
		_tmp1_ = self->priv->_worms;
		_worm_list = _tmp1_;
		_tmp2_ = _worm_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_worm_size = _tmp4_;
		_worm_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Worm* _tmp9_;
			_worm_index = _worm_index + 1;
			_tmp5_ = _worm_index;
			_tmp6_ = _worm_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _worm_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
			worm = (Worm*) _tmp8_;
			_tmp9_ = worm;
			if (_tmp9_->is_human) {
				Worm* _tmp10_;
				GeeHashMap* _tmp11_;
				_tmp10_ = worm;
				_tmp11_ = self->priv->_worm_props;
				if (worm_handle_keypress (_tmp10_, keyval, _tmp11_)) {
					result = TRUE;
					_g_object_unref0 (worm);
					return result;
				}
			}
			_g_object_unref0 (worm);
		}
	}
	result = FALSE;
	return result;
}

gboolean
nibbles_game_get_skip_score (NibblesGame* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_skip_score;
	return result;
}

void
nibbles_game_set_skip_score (NibblesGame* self,
                             gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_skip_score (self);
	if (old_value != value) {
		self->priv->_skip_score = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_SKIP_SCORE_PROPERTY]);
	}
}

gint
nibbles_game_get_current_level (NibblesGame* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_current_level;
	return result;
}

void
nibbles_game_set_current_level (NibblesGame* self,
                                gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_current_level (self);
	if (old_value != value) {
		self->priv->_current_level = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_CURRENT_LEVEL_PROPERTY]);
	}
}

gint
nibbles_game_get_speed (NibblesGame* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_speed;
	return result;
}

void
nibbles_game_set_speed (NibblesGame* self,
                        gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_speed (self);
	if (old_value != value) {
		self->priv->_speed = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_SPEED_PROPERTY]);
	}
}

gint
nibbles_game_get_gamedelay (NibblesGame* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_gamedelay;
	return result;
}

static void
nibbles_game_set_gamedelay (NibblesGame* self,
                            gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_gamedelay (self);
	if (old_value != value) {
		self->priv->_gamedelay = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_GAMEDELAY_PROPERTY]);
	}
}

guint8
nibbles_game_get_width (NibblesGame* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_width;
	return result;
}

static void
nibbles_game_set_width (NibblesGame* self,
                        guint8 value)
{
	guint8 old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_width (self);
	if (old_value != value) {
		self->priv->_width = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_WIDTH_PROPERTY]);
	}
}

guint8
nibbles_game_get_height (NibblesGame* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_height;
	return result;
}

static void
nibbles_game_set_height (NibblesGame* self,
                         guint8 value)
{
	guint8 old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_height (self);
	if (old_value != value) {
		self->priv->_height = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_HEIGHT_PROPERTY]);
	}
}

gint
nibbles_game_get_numhumans (NibblesGame* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_numhumans;
	return result;
}

void
nibbles_game_set_numhumans (NibblesGame* self,
                            gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_numhumans (self);
	if (old_value != value) {
		self->priv->_numhumans = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMHUMANS_PROPERTY]);
	}
}

gint
nibbles_game_get_numai (NibblesGame* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_numai;
	return result;
}

void
nibbles_game_set_numai (NibblesGame* self,
                        gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_numai (self);
	if (old_value != value) {
		self->priv->_numai = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMAI_PROPERTY]);
	}
}

gint
nibbles_game_get_numworms (NibblesGame* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_numworms;
	return result;
}

static void
nibbles_game_set_numworms (NibblesGame* self,
                           gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_numworms (self);
	if (old_value != value) {
		self->priv->_numworms = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMWORMS_PROPERTY]);
	}
}

GeeLinkedList*
nibbles_game_get_worms (NibblesGame* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_worms;
	result = _tmp0_;
	return result;
}

GeeHashMap*
nibbles_game_get_worm_props (NibblesGame* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_worm_props;
	result = _tmp0_;
	return result;
}

gboolean
nibbles_game_get_is_running (NibblesGame* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_running;
	return result;
}

static void
nibbles_game_set_is_running (NibblesGame* self,
                             gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_is_running (self);
	if (old_value != value) {
		self->priv->_is_running = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_IS_RUNNING_PROPERTY]);
	}
}

gboolean
nibbles_game_get_is_paused (NibblesGame* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_paused;
	return result;
}

static void
nibbles_game_set_is_paused (NibblesGame* self,
                            gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_is_paused (self);
	if (old_value != value) {
		self->priv->_is_paused = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_IS_PAUSED_PROPERTY]);
	}
}

gboolean
nibbles_game_get_fakes (NibblesGame* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_fakes;
	return result;
}

void
nibbles_game_set_fakes (NibblesGame* self,
                        gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = nibbles_game_get_fakes (self);
	if (old_value != value) {
		self->priv->_fakes = value;
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_FAKES_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
}

static void
_nibbles_game___lambda8_ (NibblesGame* self,
                          Bonus* bonus)
{
	g_return_if_fail (bonus != NULL);
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_REMOVED_SIGNAL], 0, bonus);
}

static void
__nibbles_game___lambda8__boni_bonus_removed (Boni* _sender,
                                              Bonus* bonus,
                                              gpointer self)
{
	_nibbles_game___lambda8_ ((NibblesGame*) self, bonus);
}

static GObject *
nibbles_game_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NibblesGame * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gint* _tmp2_;
	Boni* _tmp3_;
	parent_class = G_OBJECT_CLASS (nibbles_game_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_GAME, NibblesGame);
	_tmp0_ = self->priv->_width;
	_tmp1_ = self->priv->_height;
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
	self->board = (g_free (self->board), NULL);
	self->board = _tmp2_;
	self->board_length1 = _tmp0_;
	self->board_length2 = _tmp1_;
	_tmp3_ = self->priv->boni;
	g_signal_connect_object (_tmp3_, "bonus-removed", (GCallback) __nibbles_game___lambda8__boni_bonus_removed, self, 0);
	return obj;
}

static void
nibbles_game_class_init (NibblesGameClass * klass,
                         gpointer klass_data)
{
	nibbles_game_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NibblesGame_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_nibbles_game_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nibbles_game_set_property;
	G_OBJECT_CLASS (klass)->constructor = nibbles_game_constructor;
	G_OBJECT_CLASS (klass)->finalize = nibbles_game_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SKIP_SCORE_PROPERTY, nibbles_game_properties[NIBBLES_GAME_SKIP_SCORE_PROPERTY] = g_param_spec_boolean ("skip-score", "skip-score", "skip-score", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_CURRENT_LEVEL_PROPERTY, nibbles_game_properties[NIBBLES_GAME_CURRENT_LEVEL_PROPERTY] = g_param_spec_int ("current-level", "current-level", "current-level", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SPEED_PROPERTY, nibbles_game_properties[NIBBLES_GAME_SPEED_PROPERTY] = g_param_spec_int ("speed", "speed", "speed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_GAMEDELAY_PROPERTY, nibbles_game_properties[NIBBLES_GAME_GAMEDELAY_PROPERTY] = g_param_spec_int ("gamedelay", "gamedelay", "gamedelay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WIDTH_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WIDTH_PROPERTY] = g_param_spec_uchar ("width", "width", "width", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_HEIGHT_PROPERTY, nibbles_game_properties[NIBBLES_GAME_HEIGHT_PROPERTY] = g_param_spec_uchar ("height", "height", "height", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMHUMANS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMHUMANS_PROPERTY] = g_param_spec_int ("numhumans", "numhumans", "numhumans", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMAI_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMAI_PROPERTY] = g_param_spec_int ("numai", "numai", "numai", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMWORMS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMWORMS_PROPERTY] = g_param_spec_int ("numworms", "numworms", "numworms", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WORMS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WORMS_PROPERTY] = g_param_spec_object ("worms", "worms", "worms", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WORM_PROPS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WORM_PROPS_PROPERTY] = g_param_spec_object ("worm-props", "worm-props", "worm-props", GEE_TYPE_HASH_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_IS_RUNNING_PROPERTY, nibbles_game_properties[NIBBLES_GAME_IS_RUNNING_PROPERTY] = g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_IS_PAUSED_PROPERTY, nibbles_game_properties[NIBBLES_GAME_IS_PAUSED_PROPERTY] = g_param_spec_boolean ("is-paused", "is-paused", "is-paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_FAKES_PROPERTY, nibbles_game_properties[NIBBLES_GAME_FAKES_PROPERTY] = g_param_spec_boolean ("fakes", "fakes", "fakes", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	nibbles_game_signals[NIBBLES_GAME_BONUS_APPLIED_SIGNAL] = g_signal_new ("bonus-applied", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_BONUS, TYPE_WORM);
	nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL] = g_signal_new ("log-score", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
	nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL] = g_signal_new ("animate-end-game", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	nibbles_game_signals[NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL] = g_signal_new ("level-completed", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	nibbles_game_signals[NIBBLES_GAME_WARP_ADDED_SIGNAL] = g_signal_new ("warp-added", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
	nibbles_game_signals[NIBBLES_GAME_BONUS_ADDED_SIGNAL] = g_signal_new ("bonus-added", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
	nibbles_game_signals[NIBBLES_GAME_BONUS_REMOVED_SIGNAL] = g_signal_new ("bonus-removed", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
}

static void
nibbles_game_instance_init (NibblesGame * self,
                            gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GeeHashMap* _tmp1_;
	Boni* _tmp2_;
	WarpManager* _tmp3_;
	self->priv = nibbles_game_get_instance_private (self);
	_tmp0_ = gee_linked_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->_worms = _tmp0_;
	_tmp1_ = gee_hash_map_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_WORM_PROPERTIES, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->_worm_props = _tmp1_;
	_tmp2_ = boni_new ();
	self->priv->boni = _tmp2_;
	_tmp3_ = warp_manager_new ();
	self->priv->warp_manager = _tmp3_;
	self->priv->_is_running = FALSE;
	self->priv->_is_paused = FALSE;
	self->priv->main_id = (guint) 0;
	self->priv->bonus_cycle = (guint8) 0;
}

static void
nibbles_game_finalize (GObject * obj)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_GAME, NibblesGame);
	self->board = (g_free (self->board), NULL);
	_g_object_unref0 (self->priv->_worms);
	_g_object_unref0 (self->priv->_worm_props);
	_g_object_unref0 (self->priv->boni);
	_g_object_unref0 (self->priv->warp_manager);
	G_OBJECT_CLASS (nibbles_game_parent_class)->finalize (obj);
}

static GType
nibbles_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NibblesGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesGame), 0, (GInstanceInitFunc) nibbles_game_instance_init, NULL };
	GType nibbles_game_type_id;
	nibbles_game_type_id = g_type_register_static (G_TYPE_OBJECT, "NibblesGame", &g_define_type_info, 0);
	NibblesGame_private_offset = g_type_add_instance_private (nibbles_game_type_id, sizeof (NibblesGamePrivate));
	return nibbles_game_type_id;
}

GType
nibbles_game_get_type (void)
{
	static volatile gsize nibbles_game_type_id__once = 0;
	if (g_once_init_enter (&nibbles_game_type_id__once)) {
		GType nibbles_game_type_id;
		nibbles_game_type_id = nibbles_game_get_type_once ();
		g_once_init_leave (&nibbles_game_type_id__once, nibbles_game_type_id);
	}
	return nibbles_game_type_id__once;
}

static void
_vala_nibbles_game_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_GAME, NibblesGame);
	switch (property_id) {
		case NIBBLES_GAME_SKIP_SCORE_PROPERTY:
		g_value_set_boolean (value, nibbles_game_get_skip_score (self));
		break;
		case NIBBLES_GAME_CURRENT_LEVEL_PROPERTY:
		g_value_set_int (value, nibbles_game_get_current_level (self));
		break;
		case NIBBLES_GAME_SPEED_PROPERTY:
		g_value_set_int (value, nibbles_game_get_speed (self));
		break;
		case NIBBLES_GAME_GAMEDELAY_PROPERTY:
		g_value_set_int (value, nibbles_game_get_gamedelay (self));
		break;
		case NIBBLES_GAME_WIDTH_PROPERTY:
		g_value_set_uchar (value, nibbles_game_get_width (self));
		break;
		case NIBBLES_GAME_HEIGHT_PROPERTY:
		g_value_set_uchar (value, nibbles_game_get_height (self));
		break;
		case NIBBLES_GAME_NUMHUMANS_PROPERTY:
		g_value_set_int (value, nibbles_game_get_numhumans (self));
		break;
		case NIBBLES_GAME_NUMAI_PROPERTY:
		g_value_set_int (value, nibbles_game_get_numai (self));
		break;
		case NIBBLES_GAME_NUMWORMS_PROPERTY:
		g_value_set_int (value, nibbles_game_get_numworms (self));
		break;
		case NIBBLES_GAME_WORMS_PROPERTY:
		g_value_set_object (value, nibbles_game_get_worms (self));
		break;
		case NIBBLES_GAME_WORM_PROPS_PROPERTY:
		g_value_set_object (value, nibbles_game_get_worm_props (self));
		break;
		case NIBBLES_GAME_IS_RUNNING_PROPERTY:
		g_value_set_boolean (value, nibbles_game_get_is_running (self));
		break;
		case NIBBLES_GAME_IS_PAUSED_PROPERTY:
		g_value_set_boolean (value, nibbles_game_get_is_paused (self));
		break;
		case NIBBLES_GAME_FAKES_PROPERTY:
		g_value_set_boolean (value, nibbles_game_get_fakes (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_nibbles_game_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_GAME, NibblesGame);
	switch (property_id) {
		case NIBBLES_GAME_SKIP_SCORE_PROPERTY:
		nibbles_game_set_skip_score (self, g_value_get_boolean (value));
		break;
		case NIBBLES_GAME_CURRENT_LEVEL_PROPERTY:
		nibbles_game_set_current_level (self, g_value_get_int (value));
		break;
		case NIBBLES_GAME_SPEED_PROPERTY:
		nibbles_game_set_speed (self, g_value_get_int (value));
		break;
		case NIBBLES_GAME_GAMEDELAY_PROPERTY:
		nibbles_game_set_gamedelay (self, g_value_get_int (value));
		break;
		case NIBBLES_GAME_WIDTH_PROPERTY:
		nibbles_game_set_width (self, g_value_get_uchar (value));
		break;
		case NIBBLES_GAME_HEIGHT_PROPERTY:
		nibbles_game_set_height (self, g_value_get_uchar (value));
		break;
		case NIBBLES_GAME_NUMHUMANS_PROPERTY:
		nibbles_game_set_numhumans (self, g_value_get_int (value));
		break;
		case NIBBLES_GAME_NUMAI_PROPERTY:
		nibbles_game_set_numai (self, g_value_get_int (value));
		break;
		case NIBBLES_GAME_NUMWORMS_PROPERTY:
		nibbles_game_set_numworms (self, g_value_get_int (value));
		break;
		case NIBBLES_GAME_IS_RUNNING_PROPERTY:
		nibbles_game_set_is_running (self, g_value_get_boolean (value));
		break;
		case NIBBLES_GAME_IS_PAUSED_PROPERTY:
		nibbles_game_set_is_paused (self, g_value_get_boolean (value));
		break;
		case NIBBLES_GAME_FAKES_PROPERTY:
		nibbles_game_set_fakes (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

